#define	VGAPAINT_AVERAGE_C
#include <assert.h>
#include <string.h>
#include <math.h>

#include <a/bits.h>

#include "average.h"
#include "vgapaint.h"
#include "request.h"
#include "picture.h"

boolean Separate(SepFunc *proc) {	/* separate colors into RGB */
	uchar trred[256],trgrn[256],trblu[256];
	uchar *tp,*tpr,*tpg,*tpb;
	short x;

	if (!sepred) if (!(sepred=(uchar *)malloc(picbm->size))) return FALSE;
	if (!sepgrn) if (!(sepgrn=(uchar *)malloc(picbm->size))) return FALSE;
	if (!sepblu) if (!(sepblu=(uchar *)malloc(picbm->size))) return FALSE;

	mouse_hide();

	tp=pict_cur->current->frame_pal ? pict_cur->current->frame_pal->palette : pict_cur->palette;
	tpr=trred;
	tpg=trgrn;
	tpb=trblu;
	for(x=256;x;x--) {
		*tpr++=*tp++;
		*tpg++=*tp++;
		*tpb++=*tp++;
	};

	qtrncpy(sepred,picmem,picbm->size,trred);
	for(x=0;x<64;x++) vid_setRGB6(x,x<<2,0,0);
//	qmovel((ulong *)0xA0000,(ulong *)sepred,16000);
	vd->rbitblt(0,0,min(picbm->width,vidbm.width),min(picbm->height,vidbm.height),sepred,picbm->bpr,TRUE);

	proc(sepred);

	qtrncpy(sepgrn,picmem,picbm->size,trgrn);
	for(x=0;x<64;x++) vid_setRGB6(x,0,x<<2,0);
//	qmovel((ulong *)0xA0000,(ulong *)sepgrn,16000);
	vd->rbitblt(0,0,min(picbm->width,vidbm.width),min(picbm->height,vidbm.height),sepgrn,picbm->bpr,TRUE);

	proc(sepgrn);

	qtrncpy(sepblu,picmem,picbm->size,trblu);
	for(x=0;x<64;x++) vid_setRGB6(x,0,0,x<<2);
//	qmovel((ulong *)0xA0000,(ulong *)sepblu,16000);
	vd->rbitblt(0,0,min(picbm->width,vidbm.width),min(picbm->height,vidbm.height),sepblu,picbm->bpr,TRUE);

	proc(sepblu);

	return TRUE;
}

void Separate_Free(void) {
	if (sepred) { free(sepred); sepred=NULL; };
	if (sepgrn) { free(sepgrn); sepgrn=NULL; };
	if (sepblu) { free(sepblu); sepblu=NULL; };
	restore_screen();
	vid_loadRGB6(0,pict_cur->current->frame_pal ? pict_cur->current->frame_pal->palette : pict_cur->palette,256);
	mouse_show();
}

void Separate_Remap(void) {
	Separate_Remap2(sepred,sepgrn,sepblu,TRUE);
}

static uchar *SCL_Lookup_Table = NULL;
static uchar *SCL_Dither_Lookup_Red = NULL;
static uchar *SCL_Dither_Lookup_Green;
static uchar *SCL_Dither_Lookup_Blue;

void Separate_Remap2(uchar *r,uchar *g,uchar *b,boolean interactive) {
	Separate_Remap3(r,g,b,interactive);
	FreeOctree();
	if (SCL_Lookup_Table) {
		free(SCL_Lookup_Table);
		SCL_Lookup_Table = NULL;
	}
	if (SCL_Dither_Lookup_Red) {
		free(SCL_Dither_Lookup_Red);
		SCL_Dither_Lookup_Red = NULL;
	}
}

static uchar SCL_Dither_Fine[2][2]={
	102,204,
	153, 51,
};

static uchar SCL_Dither_Coarse[4][4]={
	 90,210,120,240,
	150, 30,180, 60,
	105,225, 75,195,
	165, 45,135, 15,
};

uchar SCL_Adaptive(uchar r,uchar g,uchar b) {
	return SearchOctree(r>>2,g>>2,b>>2);
}

uchar SCL_676A(uchar r,uchar g,uchar b) {
	return SCL_Lookup_Table[r] + SCL_Lookup_Table[g+256] + SCL_Lookup_Table[b+512] + 4;
}

uchar SCL_676(uchar r,uchar g,uchar b) {
	return ((r*0x0606L)>>16)*42 + ((g*0x0707L)>>16)*6 + ((b*0x0606L)>>16) + 4;
}

uchar SCL_676_Ordered(uchar r,uchar g,uchar b) {
	return (r*7+g)*6+b+4;
}

uchar SCL_666(uchar r,uchar g,uchar b) {
	return ((r*0x0606L)>>16)*36 + ((g*0x0606L)>>16)*6 + ((b*0x0606L)>>16) + 40;
}

uchar SCL_666_Ordered(uchar r,uchar g,uchar b) {
	return (r*6+g)*6+b+40;
}

typedef uchar (*separateColorLookupFuncptr)(uchar r,uchar g,uchar b);

separateColorLookupFuncptr separate_color_lookup_functions[][2]={
	{	SCL_Adaptive,	NULL,			},
	{	SCL_676A,	NULL,			},
	{	SCL_676,	SCL_676_Ordered,	},
	{	SCL_666,	SCL_666_Ordered,	},
};

void Separate_Remap3(uchar *rp,uchar *gp,uchar *bp,boolean interactive) {
	separateColorLookupFuncptr sclf;
	separateColorLookupFuncptr sclf2;
	uchar *d=picmem;
	short	*FS_mem=NULL,*FS_this,*FS_next,*FS_thisp,*FS_nextp;
	uchar	*palette = pict_cur->current->frame_pal ? pict_cur->current->frame_pal->palette : pict_cur->palette;
	long x,y,yt=0;
	long bpr,xs;
	boolean	even = TRUE;
	int	mode;

	xs=picbm->width;
	bpr=picbm->bpr;

	sclf = separate_color_lookup_functions[reduce_mode][0];
	sclf2 = separate_color_lookup_functions[reduce_mode][1];

	mode = reducedither_mode;
	if (mode == RDDMODE_FS) {
		if (FS_mem = malloc(sizeof(short)*(picbm->width + 2)*6)) {
			FS_this = FS_mem;
			FS_next = FS_mem + (picbm->width + 2)*3;
			memset(FS_mem,0,sizeof(short)*(picbm->width + 2)*6);
		} else mode = RDDMODE_NONE;
	}
	if (!sclf2 && (mode == RDDMODE_FINE || mode == RDDMODE_COARSE)) mode = RDDMODE_NONE;

	for (y=picbm->height;y;y--) {
		switch(mode) {
		case RDDMODE_FS:
		{
			int	inc;

			if (even) {
				FS_thisp = FS_this + 3;
				FS_nextp = FS_next + picbm->width*3;
				memset(FS_next,0,sizeof(short)*(picbm->width + 2)*3);
				inc = 3;
				even = FALSE;
			} else {
				FS_thisp = FS_next + picbm->width*3;
				FS_nextp = FS_this + 3;
				memset(FS_this,0,sizeof(short)*(picbm->width + 2)*3);
				inc = -3;
				even = TRUE;
			}

			x = xs;
			do {
				int r,g,b,c;

				r = (int)*rp++ + (FS_thisp[0]>>4);
				g = (int)*gp++ + (FS_thisp[1]>>4);
				b = (int)*bp++ + (FS_thisp[2]>>4);
				if (r<0) r=0; else if (r>255) r=255;
				if (g<0) g=0; else if (g>255) g=255;
				if (b<0) b=0; else if (b>255) b=255;
				c = *d++ = sclf(r,g,b);
				
				r -= (int)palette[c*3+0];
				g -= (int)palette[c*3+1];
				b -= (int)palette[c*3+2];

				if (even) {
					FS_thisp[-3]+= r*7; FS_thisp[-2]+= g*7; FS_thisp[-1]+= b*7;
					FS_nextp[ 3]+= r*3; FS_nextp[ 4]+= g*3; FS_nextp[ 5]+= b*3;
					FS_nextp[ 0]+= r*5; FS_nextp[ 1]+= g*5; FS_nextp[ 2]+= b*5;
					FS_nextp[-3]+= r*1; FS_nextp[-2]+= g*1; FS_nextp[-1]+= b*1;
				} else {
					FS_thisp[ 3]+= r*7; FS_thisp[ 4]+= g*7; FS_thisp[ 5]+= b*7;
					FS_nextp[ 3]+= r*1; FS_nextp[ 4]+= g*1; FS_nextp[ 5]+= b*1;
					FS_nextp[ 0]+= r*5; FS_nextp[ 1]+= g*5; FS_nextp[ 2]+= b*5;
					FS_nextp[-3]+= r*3; FS_nextp[-2]+= g*3; FS_nextp[-1]+= b*3;
				}

				FS_thisp += inc;
				FS_nextp -= inc;
			} while(--x);
		}
		break;

		case RDDMODE_NONE:
			x=xs;
			do {
				*d++=sclf(*rp++,*gp++,*bp++);
			} while(--x);

			break;

		case RDDMODE_FINE:	// 2x2 ordered dithering; 5 levels
			x = xs;
			do {
				uchar r,g,b;

				r = *rp++;
				g = *gp++;
				b = *bp++;

				*d++ = sclf2(
					SCL_Dither_Lookup_Red  [r*2]+(SCL_Dither_Lookup_Red  [r*2+1]>=SCL_Dither_Fine[y&1][x&1]),
					SCL_Dither_Lookup_Green[g*2]+(SCL_Dither_Lookup_Green[g*2+1]>=SCL_Dither_Fine[y&1][x&1]),
					SCL_Dither_Lookup_Blue [b*2]+(SCL_Dither_Lookup_Blue [b*2+1]>=SCL_Dither_Fine[y&1][x&1]));
			} while(--x);
			break;
		case RDDMODE_COARSE:	// 4x4 ordered dithering; 17 levels
			x = xs;
			do {
				uchar r,g,b;

				r = *rp++;
				g = *gp++;
				b = *bp++;

				*d++ = sclf2(
					SCL_Dither_Lookup_Red  [r*2]+(SCL_Dither_Lookup_Red  [r*2+1]>=SCL_Dither_Coarse[y&3][x&3]),
					SCL_Dither_Lookup_Green[g*2]+(SCL_Dither_Lookup_Green[g*2+1]>=SCL_Dither_Coarse[y&3][x&3]),
					SCL_Dither_Lookup_Blue [b*2]+(SCL_Dither_Lookup_Blue [b*2+1]>=SCL_Dither_Coarse[y&3][x&3]));
			} while(--x);
			break;
		}

		d+=(bpr-xs);
		if (interactive) {
			if (yt<vidbm.height)
				vd->rhline(0,yt++,d-bpr,vidbm.width);
		}
	};

	if (FS_mem) free(FS_mem);

	UndoInvalidate();
	PictureMarkDirty(pict_cur);
}

// Separate_Remap_FS: Same as Separate_Remap(), except use Floyd-Steinberg dithering

void	Separate_Remap_FS(void) {

	long *FS_even_mem	= NULL;
	long *FS_odd_mem	= NULL;
	long *FScur;
	long *FSnext;

	uchar *redrow=sepred,*grnrow=sepgrn,*blurow=sepblu;
	uchar *redp,*grnp,*blup;

	uchar *picrow=picmem;
	uchar *picp;

	long x,y;
	long dir;

	boolean success=FALSE;
	boolean flip=FALSE;

	struct StatusBar *sb;

	if (!(FS_even_mem=malloc(sizeof(long)*(picbm->width+2)*3))) goto abort0;
	if (!(FS_odd_mem=malloc(sizeof(long)*(picbm->width+2)*3))) goto abort1;

	sb=CreateStatusBar(picbm->height,"Colorizing picture");

	memset(FS_even_mem,0,sizeof(long)*(picbm->width+2)*3);
	memset(FS_odd_mem,0,sizeof(long)*(picbm->width+2)*3);

	for(y=picbm->height;y;y--) {
		redp = redrow;
		grnp = grnrow;
		blup = blurow;
		picp = picrow;

		if (flip=!flip) {
			FScur = FS_even_mem;
			FSnext= FS_odd_mem;

			dir = 1;

		} else {
			FScur = FS_odd_mem;
			FSnext= FS_even_mem;

			redp += picbm->width -1;
			grnp += picbm->width -1;
			blup += picbm->width -1;
			picp += picbm->width -1;

			dir = -1;

		}

		memset(FSnext,0,sizeof(long)*(picbm->width+2)*3);

		FScur  += 3;
		FSnext += picbm->width*3;

		for (x=picbm->width;x;x--) {
			long red,grn,blu;
			long r,g,b;
			int c;

			// boundaries for asserts: -1008 to 1008

			red = (((long)*redp)<<2) + (FScur[0]>>4);
			if (red<0) red=0; else if (red>255) red=255;

			grn = (((long)*grnp)<<2) + (FScur[1]>>4);
			if (grn<0) grn=0; else if (grn>255) grn=255;

			blu = (((long)*blup)<<2) + (FScur[2]>>4);
			if (blu<0) blu=0; else if (blu>255) blu=255;

			r=red; g=grn; b=blu;

//			*picp = c = SearchOctree(red>>2,grn>>2,blu>>2);
			*picp = c = FPick_Choose(fpcol,256,red,grn,blu);

			// compute & distribute errors

			red -= ((long)piccol[c*3  ])>>0;
			grn -= ((long)piccol[c*3+1])>>0;
			blu -= ((long)piccol[c*3+2])>>0;

//			*picp = red+128;

			FScur [ 1*3+0] += red*7;
			FScur [ 1*3+1] += grn*7;
			FScur [ 1*3+2] += blu*7;
			FSnext[ 1*3+0] += red;
			FSnext[ 1*3+1] += grn;
			FSnext[ 1*3+2] += blu;
			FSnext[ 0*3+0] += red*5;
			FSnext[ 0*3+1] += grn*5;
			FSnext[ 0*3+2] += blu*5;
			FSnext[-1*3+0] += red*3;
			FSnext[-1*3+1] += grn*3;
			FSnext[-1*3+2] += blu*3;

			FScur += 3;
			FSnext-= 3;
			redp += dir;
			grnp += dir;
			blup += dir;
			picp += dir;
		}

		redrow += picbm->bpr;
		grnrow += picbm->bpr;
		blurow += picbm->bpr;
		picrow += picbm->bpr;

		ModifyStatusBar(sb,picbm->height+1-y);
	}

	DestroyStatusBar(sb);

	success = TRUE;

	free(FS_odd_mem);
abort1:
	free(FS_even_mem);
abort0:
	if (!success)
		Separate_Remap();	// revert to old method
}

void AverageRGB(boolean kernel5) {
	if (Separate(kernel5 ? &AvRGBFunc5 : &AvRGBFunc))
		if (ObtainPalette())
			Separate_Remap();
	Separate_Free();
}

void sumrow(uchar *dt,ushort *sm) {
	int x,s;
	s=((int)*dt++)+((int)*dt++)+((int)*dt++);
	*sm++=s;
	for (x=picbm->width-3;x;x--) {
		s=(s-dt[-3])+*dt;
		dt++;
		*sm++=s;
	};
}

void sumrow5(uchar *dt,int *sm) {
	int x,s;

	s=((int)*dt++)+((int)*dt++)+((int)*dt++)+((int)*dt++)+((int)*dt++);
	*sm++=s;
	for (x=picbm->width-5;x;x--) {
		s=(s-dt[-5])+*dt;
		dt++;
		*sm++=s;
	};
}

void AvRGBFunc(uchar *d) {
	uchar *d2;
	ushort *sum;
	ushort *smp1,*smp2,*smp3,*smt;
	long xs,ys,x,y,s,r=2;
	long bpr=picbm->bpr;

	xs=picbm->width-2;
	ys=picbm->height-2;

	if (!(sum=(ushort *)malloc(xs*3*sizeof(short)))) return;

	smp1=sum;
	smp2=sum+xs;
	smp3=sum+xs+xs;

	d2=d+bpr+1;

	sumrow(d,smp3);	d+=bpr;
	sumrow(d,smp2);	d+=bpr;

	for(y=ys;y;y--) {
		sumrow(d,smp1);
		d+=bpr;
		for(x=xs;x;x--) {
			s=((int)*smp1++)+((int)*smp2++)+((int)*smp3++);
			*d2++=(s+4)/9;
		};
		if (r<vidbm.height)
			vd->rhline(0,r++-1,d2-xs-1,vidbm.width);
		d2+=2;
		smp1-=xs;
		smp2-=xs;
		smp3-=xs;
		smt=smp3;
		smp3=smp2;
		smp2=smp1;
		smp1=smt;
	};

	free(sum);
}

void AvRGBFunc5(uchar *d) {
	uchar *d2;
	int *sum;
	int *smp1,*smp2,*smp3,*smp4,*smp5,*smt;
	long xs,ys,x,y,s,r=2;
	long bpr=picbm->bpr;

	xs=picbm->width-4;
	ys=picbm->height-4;

	if (!(sum=(int *)malloc(sizeof(int)*xs*5))) return;

	smp1=sum;
	smp2=sum+xs;
	smp3=sum+xs+xs;
	smp4=sum+xs+xs+xs;
	smp5=sum+xs+xs+xs+xs;

	d2=d+bpr+bpr+2;

	sumrow5(d,smp5);	d+=bpr;
	sumrow5(d,smp4);	d+=bpr;
	sumrow5(d,smp3);	d+=bpr;
	sumrow5(d,smp2);	d+=bpr;

	for(y=ys;y;y--) {
		sumrow5(d,smp1);
		d+=bpr;
		for(x=xs;x;x--) {
			s=(*smp1++)+(*smp2++)+(*smp3++)+(*smp4++)+(*smp5++);
			*d2++=(s+12)/25;
		};
		if (r<vidbm.height)
			vd->rhline(0,r++-1,d2-xs-1,vidbm.width);
		d2+=4;
		smp1-=xs;
		smp2-=xs;
		smp3-=xs;
		smp4-=xs;
		smp5-=xs;
		smt=smp5;
		smp5=smp4;
		smp4=smp3;
		smp3=smp2;
		smp2=smp1;
		smp1=smt;
	};

	free(sum);
}

static void medianrow(uchar *dt,uchar *sm,ulong lsize) {
	qmovel(sm,dt,lsize);
}

static void MedianFunc(uchar *d) {
	register uchar *d2;
	uchar *sum,*smp1,*smp2,*smp3,*smt;
	register long x;
	long y;
	long xs,ys;
	long lsz,bpr;
	long r=2;

	xs=picbm->width-2;
	ys=picbm->height-2;
	bpr=picbm->bpr;
	lsz=picbm->bpr>>2;
	d2=d+bpr+1;

	if (!(sum=(uchar *)malloc(xs*3))) return;

	smp1=sum;
	smp2=sum+xs;
	smp3=sum+xs+xs;

	medianrow(d,smp3,lsz);	d+=bpr;
	medianrow(d,smp2,lsz);	d+=bpr;

	for(y=ys;y;y--) {
		medianrow(d,smp1,lsz);
		d+=bpr;
		for(x=xs;x;x--) {
			*d2++=medianswap(smp1[0],smp1[1],smp1[2],smp2[0],smp2[1],smp2[2],smp3[0],smp3[1],smp3+2);
			smp1++;
			smp2++;
			smp3++;
		};
		if (r<vidbm.height)
			vd->rhline(0,r++-1,d2+1-bpr,vidbm.width);
		d2+=2;
		smp1-=xs;
		smp2-=xs;
		smp3-=xs;
		smt=smp3;
		smp3=smp2;
		smp2=smp1;
		smp1=smt;
	};

	free(sum);
}

void MedianRGB(void) {
	if (Separate(&MedianFunc))
		if (ObtainPalette())
			Separate_Remap();
	Separate_Free();
}

void InvertRGB(void) {
	short x=768;
	uchar *cl=piccol;

	do { *cl++^=0xFF; } while(--x);

	vid_loadRGB6(0,piccol,256);
	repick_colors();
	restore_tools();
}

////////////////// COLOR REDUCTION ///////////////////////

//	MergeIdenticalColors(trnarray)
//
//	Obtain a transformation that merges similar colors together.
//
//	A value of NULL for <trnarray> forces the transformation onto the picture.

void	MergeIdenticalColors(uchar *trnarray) {
	short x;
	uchar r,g,b,*pp=piccol;
	uchar *ta;
	boolean do_it=FALSE;

	if (!trnarray) {
		do_it=TRUE;
		if (!(trnarray=(uchar *)malloc(256))) return;
	};

	ta=trnarray;

	for(x=0;x<256;x++) {
		r=*pp++; g=*pp++; b=*pp++;
		*ta++=FPick_Choose(fpcol,256,r,g,b);
	}

	if (do_it) {
		vid13_translate(picbm,0,0,picbm->width,picbm->height,trnarray);
		free(trnarray);
		restore_screen();
	};
}

struct ReducePalette {
	uchar r,g,b,i;
	ulong usecnt;
};

static int SortPictureColorsRGB(struct ReducePalette *rp1,struct ReducePalette *rp2) {
	return	 (rp1->r > rp2->r) ?  1 :
		((rp1->r < rp2->r) ? -1 :
		((rp1->g > rp2->g) ?  1 :
		((rp1->g < rp2->g) ? -1 :
		((rp1->b > rp2->b) ?  1 :
		((rp1->b < rp2->b) ? -1 : 0)))));
}
static int SortPictureColorsHigh(struct ReducePalette *rp1,struct ReducePalette *rp2) {
	return (int)(rp1->usecnt>rp2->usecnt)-(int)(rp1->usecnt<rp2->usecnt);
}
static int SortPictureColorsLow(struct ReducePalette *rp1,struct ReducePalette *rp2) {
	return (int)(rp1->usecnt<rp2->usecnt)-(int)(rp1->usecnt>rp2->usecnt);
}

void SortPictureColors(boolean reverse) {
	struct ReducePalette *rp;

	if (!(rp=(struct ReducePalette *)malloc(256*sizeof(struct ReducePalette)))) return;

	MergeIdenticalColors(NULL);
	
	{
		uchar *y=piccol;
		struct ReducePalette *z=rp;
		short x;
		for(x=256;x;x--) {
			z->r=*y++;
			z->g=*y++;
			z->b=*y++;
			z->i=256-x;
			z->usecnt=0;
			++z;
		};
	}

	{
		uchar *p=picmem;
		long x,y;

		y=picbm->height;
		do {
			x=picbm->width;
			do {
				rp[*p++].usecnt++;
			} while(--x);
			p+=(picbm->bpr-picbm->width);
		} while(--y);
	}

	qsort(rp,256,sizeof(struct ReducePalette),SortPictureColorsRGB);

	// work backwards through ReducePalette structures, pushing common colors together

	{
		struct ReducePalette *r=rp+255;
		short x;

		for(x=255;x;x--) {
			if (r[-1].r==r->r && r[-1].g==r->g && r[-1].b==r->b) {
				r[-1].usecnt+=r->usecnt;
				r->usecnt=0;
			};
			--r;
		};
	};

	qsort(rp,256,sizeof(struct ReducePalette),reverse ? SortPictureColorsLow : SortPictureColorsHigh);

	// stuff colors back into palette & compress RP structures into translation array

	{
		short x;
		uchar *y=piccol;
		struct ReducePalette *r=rp;
		uchar *z=(uchar *)rp;

		for(x=256;x;x--) {
			*y++=r->r;
			*y++=r->g;
			*y++=r->b;
			*z++=r->i;
			++r;
		};
	}

	// translate the translation array through the other translation array (confusing, huh?)

	// for each value y=tr1[x], this means that every 'i' value of <y> must translate to <x>.
	// go though the color translation array, tr2, and replace every value of <y> to <x>.

	{
		short x;
		uchar *y=(uchar *)rp,*z=(uchar *)rp+256;

		for(x=0;x<256;x++) {
			z[y[x]]=x;
		};
	}

	// retransform picture through palette reduction

	vid13_translate(picbm,0,0,picbm->width,picbm->height,(uchar *)rp+256);

	free(rp);

	repick_colors();
	restore_screen();
}

//	PCXOptimizeColors: Optimize colors for PCX saving
//
//	Single color pixels in the range 0xc0-0xff take twice as much
//	space as single color pixels in the range 0x00-0xbf.  This function
//	switches palette colors to optimize the picture for PCX compression.
//
//	The maximum space savings possible is 50%.

void	PCXOptimizeColors(void) {
	ulong	*h,tswap;
	uchar	*dm;
	int	i;
	int	y;
	uchar	c,lc;
	uchar	run;
	int	lorng_index;
	int	hirng_index;
	ulong	lorng_histo;
	ulong	hirng_histo;
	uchar	tr[256];
	int	size_delta = 0;
	ulong	total_size = 128+1+768;	// header, 0x0c byte, palette

	if (!(h=malloc(sizeof(ulong)*256))) return;
	for(i=0;i<256;i++) tr[i]=i;

	// histogram the picture for singletons

	memset(h,0,sizeof(ulong)*256);

	dm = picbm->vm;
	for(y=picbm->height;y;--y) {
		lc = *dm++;
		run = 0;
		for(i=picbm->width-1;i;--i) {
			if ((c=*dm++)==lc && run<62) {
				++run;
			} else if (!run) {
				++h[lc];
				++total_size;
				if (lc>=0xc0) ++total_size;
			} else {
				run = 0;
				total_size += 2;
			}
			lc = c;
		}
		if (!run) {
			++h[lc];
			++total_size;
			if (lc>=0xc0) ++total_size;
		} else total_size += 2;

		dm += (picbm->bpr - picbm->width);
	}


	// real braindead way to do the sort, but it works:
	//
	// 1) find the highest histo color in 0xc0-0xfe
	// 2) find the lowest histo color in 0x01-0xbf
	// 3) if histo(step 1)>histo(step 2)
	//	swap the colors and go back to step 1
	// 4) translate the picture colors

	for(;;) {
		lorng_index = 0x01;
		lorng_histo = h[0x01];
		hirng_index = 0xc0;
		hirng_histo = h[0xc0];

		for(i=0x02;i<0xc0;i++) {
			if (h[i] < lorng_histo) {
				lorng_histo = h[i];
				lorng_index = i;
			}
		}

		for(i=0xc1;i<0xff;i++) {
			if (h[i] > hirng_histo) {
				hirng_histo = h[i];
				hirng_index = i;
			}
		}

		if (lorng_histo < hirng_histo) {
			boolean	del1,del2;
			uchar	msk1,msk2;

			tswap =  h[lorng_index];  h[lorng_index]= h[hirng_index];  h[hirng_index]=tswap;
			tswap = tr[lorng_index]; tr[lorng_index]=tr[hirng_index]; tr[hirng_index]=tswap;

			// swap palbits

			msk1 = 1<<(lorng_index&7);
			msk2 = 1<<(hirng_index&7);
			del1 = !!(pict_cur->pal_bits[lorng_index>>3]&msk1);
			del2 = !!(pict_cur->pal_bits[hirng_index>>3]&msk2);

			if (del1^del2) {
				pict_cur->pal_bits[lorng_index>>3] ^= msk1;
				pict_cur->pal_bits[hirng_index>>3] ^= msk2;
			}

			// swap colors

			lorng_index *= 3;
			hirng_index *= 3;

			for(i=0;i<3;i++) {
				tswap = piccol[lorng_index+i];
				piccol[lorng_index+i]=piccol[hirng_index+i];
				piccol[hirng_index+i]=tswap;
			}

			// compute change in size

			size_delta += hirng_histo;	// this many <c1 xx> encodings become <xx>
			size_delta -= lorng_histo;	// this many <xx> encodings become <c1 xx>
		} else break;
	};

	vid13_translate(picbm,picbm->x1,picbm->y1,picbm->width,picbm->height,tr);

	free(h);

	repick_colors();
	restore_screen();

	Message("Previous size/bytes saved: %ld/%ld (%d%%)\n",total_size,size_delta,(size_delta*100)/total_size);
}


////////////////////
//
//	DeltaH: Convert a picture into a series of horizontal deltas
//

void	DeltaH(void) {
	uchar *dm1,*dm2;
	int x,y;
	uchar c,d;

	dm1 = picbm->vm;

	y = picbm->height;
	do {
		dm2=dm1;
		dm1+=picbm->bpr;
		x = picbm->width-1;
		c = *dm2++;
		do {
			d = *dm2;
			*dm2++ = d-c;
			c=d;
		} while(--x);
	} while(--y);

	reblit_screen();
}

////////////////////
//
//	UnDeltaH: Convert a series of horizontal deltas into a picture
//

void	UnDeltaH(void) {
	uchar *dm1,*dm2;
	int x,y;
	uchar c;

	dm1 = picbm->vm;

	y = picbm->height;
	do {
		dm2=dm1;
		dm1+=picbm->bpr;
		x = picbm->width-1;
		c = *dm2++;
		do {
			c = (*dm2++ += c);
		} while(--x);
	} while(--y);

	reblit_screen();
}


///////////////////
//
//	DeltaV: Convert a picture into a series of vertical deltas
//

void	DeltaV(void) {
	uchar	*dm1,*dm2;
	int	x,y;
	uchar	c,d;

	dm1 = picbm->vm;

	x = picbm->width;
	do {
		dm2=dm1++;
		y = picbm->height-1;
		c = *dm2;	dm2 += picbm->bpr;
		do {
			d = *dm2;
			*dm2 = d-c;
			dm2 += picbm->bpr;
			c=d;
		} while(--y);
	} while(--x);

	reblit_screen();
}

///////////////////
//
//	UnDeltaV: Convert a series of vertical deltas into a picture
//

void	UnDeltaV(void) {
	uchar	*dm1,*dm2;
	int	x,y;
	uchar	c;

	dm1 = picbm->vm;

	x = picbm->width;
	do {
		dm2=dm1++;
		y = picbm->height-1;
		c = *dm2;
		dm2 += picbm->bpr;
		do {
			c = (*dm2 += c);
			dm2 += picbm->bpr;
		} while(--y);
	} while(--x);

	reblit_screen();
}


/******* PALETTE COMPUTATION ROUTINES *******/

#pragma off (check_stack);

static uchar OctMaxDepth;

// OrderedDitherMakeInterpolation: make an interpolation table (duh)

void OrderedDitherMakeInterpolation(uchar *tbl,int levels) {
	int	i;
	ulong	accum	= 0;
	ulong	ainc	= (0x10000L*(levels-1))/255;

	for(i=0;i<256;i++) {
		tbl[0] = accum>>16;
		tbl[1] = (uchar)(accum>>8);
		tbl += 2;
		accum += ainc;
	}
}

/* ObtainPalette: Obtain a new palette from RGB screens */

boolean ObtainPalette(void) {
	return ObtainPalette2(sepred,sepgrn,sepblu,TRUE,reduce_maxcol);
}

boolean ObtainPalette2(uchar *r,uchar *g,uchar *b,boolean interactive,ushort maxcol) {
	return ObtainPalette3(r,g,b,interactive,FALSE,maxcol,reduceplace_mode);
}

static uchar expand6[]={ 0,51,102,153,204,255 };
static uchar expand7[]={ 0,43,85,128,170,213,255 };

boolean ObtainPalette3(uchar *rp,uchar *gp,uchar *bp,boolean interactive,boolean addpal,int maxcol,int placement) {
	ulong i;
	ulong z=0x00100000;
	struct StatusBar *sb;
	uchar *palette;

	if (!addpal) OctreeInit();

	if (interactive) reset_colors();

	palette = pict_cur->current->frame_pal ? pict_cur->current->frame_pal->palette : pict_cur->palette;

	memcpy(palette,stdcol,48);

	switch(reduce_mode) {
	case RDCMODE_ADAPTIVE:
		if (interactive)
			sb=CreateStatusBar(picbm->size,"Reducing palette...");
		else
			sb=NULL;

		for (i=picbm->size;i;i--) {
			if (!InsertColor(&OctRoot,*rp++>>2,*gp++>>2,*bp++>>2,0)) return FALSE;
			if (leafcnt>maxcol*2) ReduceOctree(maxcol);
			if (!(z+=0x00100000))
				ModifyStatusBar(sb,picbm->size-i);
		};
		if (leafcnt>maxcol) ReduceOctree(maxcol);

		if (sb)	DestroyStatusBar(sb);

		// attach a new palette to the current picture if we have more than 1 frame

		if (pict_cur->total_frames>1) {
			DetachFramePalette(pict_cur,pict_cur->current);
			AttachPaletteToFrame(pict_cur,pict_cur->current,NULL);
		}

		if (!addpal) AssignOctree(placement);

//		if (curcreg)
//			memcpy(palette,stdcol,min(48,curcreg*3));
		break;

	case RDCMODE_6x7x6A:
		{
			uchar rlvl[6],glvl[7],blvl[6],r,g,b;
			uchar *pptr = palette + 3*4;

			if (!(SCL_Lookup_Table = malloc(768))) return FALSE;

			ObtainGreyPalette(rp,picbm->width,picbm->height,picbm->bpr,rlvl,6,SCL_Lookup_Table+  0);
			ObtainGreyPalette(gp,picbm->width,picbm->height,picbm->bpr,glvl,7,SCL_Lookup_Table+256);
			ObtainGreyPalette(bp,picbm->width,picbm->height,picbm->bpr,blvl,6,SCL_Lookup_Table+512);

			for(i=0;i<256;i++) {
				SCL_Lookup_Table[i    ] *= 42;
				SCL_Lookup_Table[i+256] *= 6;
			}

			for(r=0;r<6;r++)
				for(g=0;g<7;g++)
					for(b=0;b<6;b++) {
						*pptr++ = rlvl[r];
						*pptr++ = glvl[g];
						*pptr++ = blvl[b];
					}
		}
		break;
	case RDCMODE_6x7x6:
		{
			uchar r,g,b;
			uchar *pptr = palette + 3*4;

			for(r=0;r<6;r++)
				for(g=0;g<7;g++)
					for(b=0;b<6;b++) {
						*pptr++ = expand6[r];
						*pptr++ = expand7[g];
						*pptr++ = expand6[b];
					}
		}
		break;
	case RDCMODE_6x6x6:
		{
			uchar r,g,b;
			uchar *pptr = palette + 3*40;

			for(r=0;r<6;r++)
				for(g=0;g<6;g++)
					for(b=0;b<6;b++) {
						*pptr++ = expand6[r];
						*pptr++ = expand6[g];
						*pptr++ = expand6[b];
					}
		}
		break;
	}

	// make the ordered dithering table if we need to

	if (reducedither_mode==RDDMODE_COARSE || reducedither_mode==RDDMODE_FINE) {
		switch(reduce_mode) {
		// RDCMODE_ADAPTIVE does not support ordered dithering

		case RDCMODE_6x7x6:
			if (!(SCL_Dither_Lookup_Red = malloc(1024))) {
				free(SCL_Lookup_Table);
				SCL_Lookup_Table=NULL;
				return FALSE;
			}
			OrderedDitherMakeInterpolation(SCL_Dither_Lookup_Blue = SCL_Dither_Lookup_Red,6);
			OrderedDitherMakeInterpolation(SCL_Dither_Lookup_Green = SCL_Dither_Lookup_Red+512,7);
			break;
		case RDCMODE_6x6x6:
			if (!(SCL_Dither_Lookup_Red = malloc(512))) {
				free(SCL_Lookup_Table);
				SCL_Lookup_Table=NULL;
				return FALSE;
			}
			OrderedDitherMakeInterpolation(SCL_Dither_Lookup_Blue = SCL_Dither_Lookup_Green = SCL_Dither_Lookup_Red,6);
			break;
		}
	}

	if (interactive) vid_loadRGB6(0,palette,256);

	/* you must free octree yourself */

	if (interactive) repick_colors();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//
//	boolean	ObtainGreyPalette(const uchar *d,long xs,long ys,long bpr,
//		uchar *lvls,int maxlevels,uchar *invpal);
//
//	Find the optimal quantization levels for a one-dimensional signal
//	by using the median cut method.
//

void	ObtainGreyPalette(const uchar *d,long xs,long ys,long bpr,uchar *lvls,int maxlevels,uchar *invpal) {
	ulong	histo[256];
	long	xst;
	int	mn,mx,i,j;
	ulong	tpixels,pixttl=0,pixmin=0;

	// histogram...
	
	memset(histo,0,sizeof histo);
	bpr -= xs;
	do {
		xst = xs;
		do
			++histo[*d++];
		while(--xst);
		d += bpr;
	} while(--ys);

	// find the minimum and maximum

	for(mn=0;mn<255;mn++) if (histo[mn]) { lvls[0] = mn; break; }
	for(mx=255;mx;mx--) if (histo[mx]) { lvls[maxlevels-1]=mx; break; }

	memset(invpal,0,mn);
	memset(invpal+mx,maxlevels-1,256-mx);

	// if the range is <= # of levels set the intermediates and finish

	if (mx+1-mn <= maxlevels) {
		for(i=1;i<(mx+1-mn);i++) lvls[i] = mn+i;
		for(i=mx+1-mn;i<maxlevels-1;i++) lvls[i]=mx;	// flatten the upper range

		for(i=mn;i<mx;i++) invpal[i]=i-mn;
		return;
	}

	tpixels=0;
	for(i=mn;i<=mx;i++) {
		tpixels += histo[i] = ceil(sqrt(histo[i]));
	}

	// compute the intermediate ranges
	// 50% = 50% of the pixels

	j = mn;
	for(i=1;i<maxlevels-1;i++) {
		pixmin = (tpixels*i)/maxlevels;
		while((pixttl += histo[j++])<pixmin)
			;
		lvls[i] = j;
	}

	// compute inverse lookup (lazy)

	j = 0;
	for(i=mn+1;i<mx;i++) {
		if (j<(maxlevels-1))
			if (abs(lvls[j+1]-i) < abs(i-lvls[j])) ++j;

		invpal[i]=j;
	}
}

//////////////////////////// OCTREE QUANTIZATION /////////////////////////

void OctreeInit(void) {
	short j;
	memset(&OctRoot,0,sizeof(struct Octree));
	OctRoot.level=32;
	leafcnt=0;
	OctMaxDepth=6;
	for (j=0;j<6;j++) {
		NewList(&OctList[j]);
		OctDepthCnt[j]=0;
	};
}

struct Octree *InitOctree(short level) {
	struct Octree *oct;

	if (!(oct=(struct Octree *)malloc(sizeof(struct Octree)))) return NULL;
	memset(oct,0,sizeof(struct Octree));
	oct->level=level;
	return oct;
}

boolean InsertColor(struct Octree *oct,uchar r,uchar g,uchar b,uchar depth) {
	struct Octree *leaf;
	uchar i,lv;

#if 0
	++oct->pixcnt;
	oct->rsum+=r;
	oct->gsum+=g;
	oct->bsum+=b;
#endif

	if (!(lv=oct->level) || depth>OctMaxDepth) {
		return TRUE;
	};

//	i=((r & lv)?4:0)+((g & lv)?2:0)+((b & lv)?1:0);
	i=0;
	if (r&lv) i=4;
	if (g&lv) i+=2;
	if (b&lv) ++i;

	if (oct->Next[i]) {
		return InsertColor(oct->Next[i],r,g,b,depth+1);
	} else {
		if (!(leaf=InitOctree(oct->level>>1))) return FALSE;
		oct->Next[i]=leaf;
		_AddHead(&OctList[depth],&leaf->levlst);
		leaf->Parent=oct;
		++leafcnt;

		// determine if the node we are attaching the leaf to needs
		// to be transformed from a leaf to a node

		// we cannot do this if multiple leaves have been attached,
		// since whenever a node with leaves is pruned it becomes
		// a leaf itself

		if (oct->leaf && !oct->leafcnt) {
			--leafcnt;
			oct->leaf=FALSE;
			oct->pixcnt=oct->rsum=oct->gsum=oct->bsum=0;
		};
		oct->leafcnt = 1;

		OctDepthCnt[depth]++;
		leaf->leaf=TRUE;
#if 1
		if (leaf->level && depth<OctMaxDepth) {
#else
		if (leaf->level) {
#endif
			return InsertColor(leaf,r,g,b,depth+1);
		} else {
			leaf->rsum=r;
			leaf->gsum=g;
			leaf->bsum=b;
			leaf->pixcnt=1;
		};
	};

	return TRUE;
}
	
/* ReduceOctree: Prune smallest group of leaves from tree
** 		Call only when needed! */

void ReduceOctree(int maxcol) {
	int	i,j;
	struct Octree *oct;


	do {
		for (i=5;i>=0;i--) if ((oct=(struct Octree *)(OctList[i].next))->levlst.next) goto accept;
		return;
accept:
		oct=oct->Parent;

#if 0
		for(j=0;j<8;j++) {
			if (oct->Next[j]) {
				_Remove(&oct->Next[j]->levlst);
				free(oct->Next[j]);
				oct->Next[j]=NULL;
				oct->leafcnt--;
				leafcnt--;
				OctDepthCnt[i]--;
				if (leafcnt<=maxcol) {
					// check to see if this node is now a leaf

					if (	   !oct->Next[0]
						&& !oct->Next[1]
						&& !oct->Next[2]
						&& !oct->Next[3]
						&& !oct->Next[4]
						&& !oct->Next[5]
						&& !oct->Next[6]
						&& !oct->Next[7]) break;	//aaargh

					if (!OctDepthCnt[i]) OctMaxDepth=i-1;

					return;
				}
			};
		};
		if (!OctDepthCnt[i]) OctMaxDepth=i-1;
		oct->leaf=TRUE;
		++leafcnt; /* got rid of all leaves but this branch is now a leaf */
#else

		// first, check to see if the current node is a leaf
		// if it is not, pull the first color off and convert the existing node to a leaf

		if (!oct->leaf) {
			for(j=0;j<8;j++)
				if (oct->Next[j]) {
					oct->pixcnt	+= oct->Next[j]->pixcnt;
					oct->rsum	+= oct->Next[j]->rsum;
					oct->gsum	+= oct->Next[j]->gsum;
					oct->bsum	+= oct->Next[j]->bsum;

					_Remove(&oct->Next[j]->levlst);
					free(oct->Next[j]);
					oct->Next[j]=NULL;
					OctDepthCnt[i]--;
					break;
				}

			oct->leaf=TRUE;
		}

		// next, we are still above the quota, continue to prune off leaves

		for(j=0;j<8 && leafcnt>maxcol;j++)
			if (oct->Next[j]) {
				oct->pixcnt	+= oct->Next[j]->pixcnt;
				oct->rsum	+= oct->Next[j]->rsum;
				oct->gsum	+= oct->Next[j]->gsum;
				oct->bsum	+= oct->Next[j]->bsum;

				_Remove(&oct->Next[j]->levlst);
				free(oct->Next[j]);
				oct->Next[j]=NULL;
				--leafcnt;
				OctDepthCnt[i]--;
			}
		if (!OctDepthCnt[i]) OctMaxDepth=i;
#endif
	} while(leafcnt>maxcol);
}

/* FreeOctree: Free octree structure */

void FreeOctree(void) {
	short j;
	for(j=0;j<8;j++) if (OctRoot.Next[j]) FreeOctree2(OctRoot.Next[j]);
}

void FreeOctree2(struct Octree *oct) {
	short j;
	for (j=0;j<8;j++) if (oct->Next[j]) FreeOctree2(oct->Next[j]);
	free(oct);
}

/* AssignOctree: Assign colors to all octree leaves */

static uchar *octcol;

void AssignOctree(int placement) {
	octcol=(pict_cur->current->frame_pal ? pict_cur->current->frame_pal->palette : pict_cur->palette);
	curcreg=0;
	AssignOctree2(&OctRoot,placement);
}

void AssignOctree2(struct Octree *oct,int placement) {
	int j;
	boolean has_leaves = FALSE;

	for (j=0;j<8;j++) if (oct->Next[j]) { AssignOctree2(oct->Next[j],placement); has_leaves = TRUE; }

	if (oct->leaf) {
		oct->creg = curcreg;

		if (!has_leaves) oct->level=0;
		octcol[curcreg*3L+0]=expand6to8(oct->rsum/oct->pixcnt);
		octcol[curcreg*3L+1]=expand6to8(oct->gsum/oct->pixcnt);
		octcol[curcreg*3L+2]=expand6to8(oct->bsum/oct->pixcnt);

		if (placement)
			++curcreg;
		else
			--curcreg;
	};
}

/* SearchOctree: Search the Octree for a particular color */

uchar SearchOctree(uchar r,uchar g,uchar b) {
	uchar lv,t;
	struct Octree *oc,*oct = &OctRoot;

	while(lv=oct->level) {
		t=0;
		if (r & lv) t+=4;
		if (g & lv) t+=2;
		if (b & lv) ++t;

#if 0
		// this code works but causes bad hue shifts with few #'s of colors

		while(!(oc=oct->Next[t]))
			if (++t>=8) t=0;
		oct=oc;
#else
		if (!(oc = oct->Next[t]))
			if (oct->leaf)
				return oct->creg;
			else
				while(!(oc=oct->Next[t]))
					if (++t>=8) t=0;
		oct = oc;
#endif
	}
	return oct->creg;
}


