#define	EXTENSION

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <dos.h>
#include <math.h>

#include "extdata.h"
#include "request.h"
#include "listbox.h"
#include "mouse.h"
#include "video.h"

//#pragma aux     __CMain  "*";
//extern	void	__CommonInit( void );
//void _CMain(void) { __CommonInit(); main(); exit(0); }

char *	equ_scan(char *eqtn,short *tokmem);
double	equ_eval_dbl(short *tokstream,double *stack,double *vars);

extern short math_error;

#define	GR_X	4
#define	GR_Y	15

struct Rectangle gc_neg[]={
	{   2, 13,164,104 },
	{   2,120,164, 11 },
	{   2,132,164, 11 },
	{  19,186,298, 11 },
	{  19,173,298, 11 },
	{  19,160,298, 11 },
	{  19,147,298, 11 },
	{ RECT_END }
};

struct Rectangle gc_pos[]={
	{  18,185,300, 13 },
	{  18,172,300, 13 },
	{  18,159,300, 13 },
	{  18,146,300, 13 },
	{ RECT_END }
};

char equation[4][256];

struct Field gc_fld[]={
	{ 21,188,294,8,NULL,equation[0],0,0,255,49,St0,St2,NULL,0,0,0 },
	{ 21,175,294,8,NULL,equation[1],0,0,255,49,St0,St2,NULL,0,0,0 },
	{ 21,162,294,8,NULL,equation[2],0,0,255,49,St0,St2,NULL,0,0,0 },
	{ 21,149,294,8,NULL,equation[3],0,0,255,49,St0,St2,NULL,0,0,0 },
	{ -1,-1,-1,-1 }
};

struct Zone gc_zone1[]={
	{ 198, 13, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Clear",NULL },
	{ 258, 13, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Graph",NULL },
	{ 198, 24, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Range",NULL },
	{ 258, 24, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Trace",NULL },
	{ 198, 35, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,".5x",NULL },
	{ 258, 35, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"2x",NULL },
	{ 198, 46, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"ZoomWin",NULL },
	{ 258, 46, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"ZoomPt",NULL },
	{ 198, 57, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"LockMax",NULL },
	{ 258, 57, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"LockMin",NULL },
	{ 198, 68, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"LockZero",NULL },
	{ 258, 68, 60, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Evaluate",NULL },
	{ -1,-1,-1,-1 },
};

struct Zone gc_zone2[]={
	{   2,185, 15, 13,ZN_3D+ZN_TEXTRENDER+ZN_INVERTED,NULL,"Y=",NULL },
	{   2,172, 15, 13,ZN_3D+ZN_TEXTRENDER+ZN_INVERTED,NULL,"Y=",NULL },
	{   2,159, 15, 13,ZN_3D+ZN_TEXTRENDER+ZN_INVERTED,NULL,"Y=",NULL },
	{   2,146, 15, 13,ZN_3D+ZN_TEXTRENDER+ZN_INVERTED,NULL,"Y=",NULL },
	{ -1,-1,-1,-1 },
};

struct ZoneRange gc_zr[]={
	{ &gc_zr[1]	,gc_zone1,NULL,-1,ZR_TAP   ,NULL,-1,0,NULL,0 },
	{ NULL		,gc_zone2,NULL,-1,ZR_TOGGLE,NULL,-1,0,NULL,0 },
};

struct Requester gc_req={
	0,0,320,200,
	REQ_BORDER+REQ_NODRAG,
	"VP386 Graphing Calculator",
	St2,
	NULL,
	gc_fld,
	gc_zr,
	NULL,
	gc_pos,
	gc_neg,
	NULL,
	NULL
};

#define	isnan(x)	(!*(ulong *)&x && (*(((ulong *)&x)+1) & 0xfff7ffff)==0xfff00000)
#define	isinf(x)	(!*(ulong *)&x && (*(((ulong *)&x)+1) & 0x7fffffff)==0x7ff00000)
#define	REALX(x)	((((x)-Xmin)*160)/Xdif)
#define	REALY(y)	(100-(((y)-Ymin)*100)/Ydif)
#define	GRPHX(x)	(((x)*Xdif)/160+Xmin)
#define	GRPHY(y)	(((100-(y))*Ydif)/100+Ymin)

typedef	char	(*FindPointFunc)(double y1,double y2,double y3);

void	TitleMessage(char *);
void	ClearMessage(void);

void	GetPoint(coord *x1,coord *y1);
void	GetWindow(coord *x1,coord *y1,coord *x2,coord *y2);
void	GetXRange(coord *x1,coord *x2);

void	ResetPos(void);
void	RedrawScale(void);

void	Graph(void);
void	GraphEquation(short *equat,color c);

char	FPRoot(double y1,double y2,double y3);
char	FPMin(double y1,double y2,double y3);
char	FPMax(double y1,double y2,double y3);
void	FindPoint(FindPointFunc func);

void	RangeRequest(void);

static short	equ_tok[4][1024];	// the tokenized equations
static boolean	equ_valid[4]={ 0,0,0,0 };	// set only when equation has been correctly tokenized

static double	Xmin=-10.0,		// X-left
		Xmax= 10.0,		// X-right
		Ymin=-10.0,		// Y-bottom
		Ymax= 10.0,		// Y-top
		Xscl=  1.0,		// X-tick-marks
		Yscl=  1.0,		// Y-tick-marks
		Xdif= 20.0,		// Ymax-Ymin
		Ydif= 20.0,		// Xmax-Xmin
		Xpos=  0.0,		// Last trace X location, or 0.0 if newly graphed
		Ypos=  0.0;		// Last trace Y location, or 0.0 if newly graphed
static double	stack[512]; 		// evaluation stack
static double	vars[26];   		// variables

static boolean	cursor=FALSE;		// is the trace cursor active?
static coord	cursx,cursy;		// cursor coordinates

static struct BitMap graphbm;		// graph window bitmap

void main(void) {
	mouse_coord mx,my,mb;
	boolean quit=FALSE;
	ulong msg;

	if (!OpenRequester(&gc_req,0,0)) return;

	for(mx=0;mx<4;mx++)
		(*_vd)->text6(&gc_req.reqbm,gc_zone2[mx].x+1,gc_zone2[mx].y+3,"Y",mx+1,ST2);
	
	vid_initBitMap(&graphbm,_vidbm->vm+GR_Y*_vidbm->bpr+GR_X,0,0,160,100,_vidbm->bpr,_vidbm->pal);
	RedrawScale();

	do {
		mouse_wait_unkey();
		mouse_wait_key();
		mouse_read2(&mx,&my,&mb);
		ClearMessage();

		switch(msg=CheckRequester(&gc_req,mx,my,mb)) {
		case REQM_DRAGGED:
			quit=TRUE;
			break;
		case REQM_FIELD+0:	/* Y= field */
		case REQM_FIELD+1:
		case REQM_FIELD+2:
		case REQM_FIELD+3:
			msg-=REQM_FIELD;
			if (!equ_scan(equation[msg],equ_tok[msg])) {
				TitleMessage("Error: Syntax error in equation.");
				equ_valid[msg]=FALSE;
			} else {
				equ_valid[msg]=TRUE;
			};
			break;
		case RZoneMsg(0,0):	// clear
			RedrawScale();
			break;
		case RZoneMsg(0,1):	// graph
			Graph();
			break;
		case RZoneMsg(0,2):	// range
			RangeRequest();
			break;
		case RZoneMsg(0,3):	// trace
			Trace();
			break;
		case RZoneMsg(0,4):	// .5x
			Ymin=Ypos-Ydif;
			Ydif=Ydif*2;
			Ymax=Ymin+Ydif;
			Xmin=Xpos-Xdif;
			Xdif=Xdif*2;
			Xmax=Xmin+Xdif;
			RedrawScale();
			Graph();
			break;
		case RZoneMsg(0,5):	// .2x
			Ydif=Ydif/2;
			Ymin=Ypos-Ydif/2;
			Ymax=Ymin+Ydif;
			Xdif=Xdif/2;
			Xmin=Xpos-Xdif/2;
			Xmax=Xmin+Xdif;
			RedrawScale();
			Graph();
			break;
		case RZoneMsg(0,6):	// ZoomWin
			{
				coord x1,y1,x2,y2;
				double XMIN,YMIN;

				GetWindow(&x1,&y1,&x2,&y2);

				XMIN=GRPHX(x1);
				Xmax=GRPHX(x2);	Xmin=XMIN;
				YMIN=GRPHY(y1);
				Ymax=GRPHY(y2);	Ymin=YMIN;
				Xdif=Xmax-Xmin;
				Ydif=Ymax-Ymin;
				RedrawScale();
				Graph();
			}
			break;
		case RZoneMsg(0,7):	// ZoomPt
			{
				coord x1,y1;
				double XMIN,YMIN;

				GetPoint(&x1,&y1);

				XMIN=GRPHX(x1-1);
				Xmax=GRPHX(x1+1);	Xmin=XMIN;
				YMIN=GRPHY(y1+1);
				Ymax=GRPHY(y1-1);	Ymin=YMIN;
				Xdif=Xmax-Xmin;
				Ydif=Ymax-Ymin;
				RedrawScale();
				Graph();
			}
			break;
		case RZoneMsg(0,8):
			FindPoint(&FPMax);
			break;
		case RZoneMsg(0,9):
			FindPoint(&FPMin);
			break;
		case RZoneMsg(0,10):
			FindPoint(&FPRoot);
			break;
		case RZoneMsg(0,11):
			FreeEvaluate();
			break;
		};
	} while(!quit);

	mouse_wait_unkey();
	CloseRequester(&gc_req);
}

static boolean message=FALSE;

void TitleMessage(char *msg) {
	mouse_hide();
	(*_vd)->bar(&gc_req.reqbm,1,1,318,9,ST2);
	(*_vd)->text6(&gc_req.reqbm,160-3*strlen(msg),2,msg,ST0,ST2);
	mouse_show();
	(*_vd)->refresh();
	message=TRUE;
}

void ClearMessage(void) {
	if (!message) return;
	mouse_hide();
	(*_vd)->bar(&gc_req.reqbm,1,1,318,9,ST2);
	(*_vd)->text6(&gc_req.reqbm,85,2,"VP386 Graphing Calculator",ST0,ST2);
	mouse_show();
	(*_vd)->refresh();
	message=FALSE;
}


//	ResetPos()
//
//	Reset graphing position

void	ResetPos(void) {

	if (cursor) {
		cursor=FALSE;
		mouse_hide();
		(*_vd)->hline(&graphbm,0,159,cursy,-1);
		(*_vd)->vline(&graphbm,cursx,0,99,-1);
		(*_vd)->bar(&gc_req.reqbm,4,122,160,8,ST2);
		(*_vd)->bar(&gc_req.reqbm,4,134,160,8,ST2);
		mouse_show();
		(*_vd)->refresh();
	};

	Xpos=(Xmin+Xmax)/2;
	Ypos=(Ymin+Ymax)/2;
}

//	ShiftPos(x,y)
//
//	Move graphing position

void	ShiftPos(coord x,coord y,double rx,double ry) {
	mouse_hide();
	if (cursor) {
		(*_vd)->hline(&graphbm,0,159,cursy,-1);
		(*_vd)->vline(&graphbm,cursx,0,99,-1);
	};
	if (x>=0 && x<160 && y>=0 && y<100) {
		(*_vd)->hline(&graphbm,0,159,cursy=y,-1);
		(*_vd)->vline(&graphbm,cursx=x,0,99,-1);
	} else	cursor=FALSE;
	vid_printf6(&gc_req.reqbm,4,122,ST0,ST2,"X = %-22.14g",rx);
	vid_printf6(&gc_req.reqbm,4,134,ST0,ST2,"Y = %-22.14g",ry);
	(*_vd)->refresh();
	mouse_show();
	cursor=TRUE;
}

//	Trace()
//
//	Activate tracing function.

void	Trace(void) {
	MouseBound	mbnd;
	mouse_coord	mx,my,mb;
	boolean		found;
	boolean		valid=FALSE;
	short i;
	double		rpx,pty,ty,tdist,ldist,py,rpy,valid_px;
	coord		lpy,px;

	mouse_readlimits(&mbnd);
	mouse_setlimits(GR_X<<1,GR_Y,(GR_X<<1)+319,GR_Y+99);

	for(;;){
		mouse_readmove(&mx,&my,&mb);
		if (mb) break;

		px=mx-GR_X;
		py=GRPHY(my-GR_Y);
		rpx=GRPHX(px);

		found=FALSE;

		// evaluate expressions one by one until nearest one is found

		for(i=0;i<4;i++)
			if (equ_valid[i])
				if (gc_zone2[i].flags & ZN_INVERTED) {
					vars['x'-'a']=rpx;
					ty=equ_eval_dbl(equ_tok[i],stack,vars);
					if ((!math_error)&&!isnan(ty)&&!isinf(ty)) {
						tdist=fabs(ty-py);
						pty=REALY(ty);
						if (pty>=0 && pty<100)
							switch(found) {
							case TRUE:
								if (tdist>=ldist) break;
							case FALSE:
								found=valid=TRUE;
								ldist=tdist;
								lpy=pty;
								rpy=ty;
								valid_px=rpx;
							};
					};
				};

		if (found) ShiftPos(px,lpy,valid_px,rpy);
	}

	mouse_writelimits(&mbnd);
	mouse_wait_unkey();

	if (valid) {
		Xpos=valid_px;
		Ypos=rpy;
	};
}

//	GetPoint()
//
//	Allow user to pick a point on the display.

void	GetPoint(coord *grx,coord *gry) {
	MouseBound	mbnd;
	mouse_coord	mx,my,mb;

	mouse_readlimits(&mbnd);
	mouse_setlimits(GR_X<<1,GR_Y,(GR_X<<1)+319,GR_Y+99);

	do {
		mouse_readmove(&mx,&my,&mb);
	} while(!mb);

	mouse_writelimits(&mbnd);
	mouse_wait_unkey();

	*grx=mx-GR_X;
	*gry=my-GR_Y;
}

//	GetWindow()
//
//	Allow user to pick a point on the display.

void	GetWindow(coord *x1,coord *y1,coord *x2,coord *y2) {
	MouseBound	mbnd;
	mouse_coord	mx,my,mb,mx2,my2;
	coord		ox,oy;

	mouse_readlimits(&mbnd);
	mouse_setlimits(GR_X<<1,GR_Y,(GR_X<<1)+319,GR_Y+99);

	do {
		mouse_readmove(&mx,&my,&mb);
	} while(!mb);

	mx2=mx;
	my2=my;

	do {
		mouse_hide();
		(*_vd)->box(&gc_req.reqbm,mx,my,ox=mx2,oy=my2,-1);
		mouse_show();
		mouse_readmove(&mx2,&my2,&mb);
		mouse_hide();
		(*_vd)->box(&gc_req.reqbm,mx,my,ox,oy,-1);
		mouse_show();
	} while(mb);

	mouse_writelimits(&mbnd);
	mouse_wait_unkey();

	if (mx>mx2) { mouse_coord t; mx=t; mx=mx2; mx2=t; };
	if (my<my2) { mouse_coord t; my=t; my=my2; my2=t; };

	*x1=mx -GR_X;
	*y1=my -GR_Y;
	*x2=mx2-GR_X;
	*y2=my2-GR_Y;
}

//	GetXRange()
//
//	Allow user to pick horizontal range on the display.

void	GetXRange(coord *x1,coord *x2) {
	MouseBound	mbnd;
	mouse_coord	mx,my,mb,mx2;
	coord		ox;

	mouse_readlimits(&mbnd);
	mouse_setlimits(GR_X<<1,GR_Y,(GR_X<<1)+319,GR_Y+99);

	do {
		mouse_readmove(&mx,&my,&mb);
	} while(!mb);

	mx2=mx;

	do {
		mouse_hide();
		(*_vd)->bar(&gc_req.reqbm,min(mx,mx2),GR_Y,abs((ox=mx2)-mx)+1,100,-1);
		mouse_show();
		mouse_readmove(&mx2,&my,&mb);
		mouse_hide();
		(*_vd)->bar(&gc_req.reqbm,min(mx,ox),GR_Y,abs(ox-mx)+1,100,-1);
		mouse_show();
	} while(mb);

	mouse_writelimits(&mbnd);
	mouse_wait_unkey();

	if (mx>mx2) { mouse_coord t; mx=t; mx=mx2; mx2=t; };

	*x1=mx -GR_X;
	*x2=mx2-GR_X;
}

//	RedrawScale()
//
//	Clear the graphing screen and redraw the scale.

void	RedrawScale(void) {
	double x,y;

	ResetPos();

	mouse_hide();
	(*_vd)->bar  (&graphbm,0,  0,160,100,ST0);
	(*_vd)->hline(&graphbm,0,159,REALY(0),ST1);
	(*_vd)->vline(&graphbm,REALX(0),0,99,ST1);

	if (Xscl)
		if (fabs(Xdif)/Xscl<160) { // if not too crowded
			if (Xmin<Xmax) {
				if (Xmin<=0 && Xmax>=0) {
					x=0;
					while((x+=Xscl)<=Xmax)
						(*_vd)->plot(&graphbm,REALX(x),REALY(0)-1,ST1);
					x=0;
					while((x-=Xscl)>=Xmin)
						(*_vd)->plot(&graphbm,REALX(x),REALY(0)-1,ST1);
				};
			} else {
				if (Xmax<=0 && Xmin>=0) {
					x=0;
					while((x+=Xscl)<=Xmin)
						(*_vd)->plot(&graphbm,REALX(x),REALY(0)-1,ST1);
					x=0;
					while((x-=Xscl)>=Xmax)
						(*_vd)->plot(&graphbm,REALX(x),REALY(0)-1,ST1);
				};
			};
		};

	if (Yscl)
		if (fabs(Ydif)/Yscl<160) { // if not too crowded
			if (Ymin<Ymax) {
				if (Ymin<=0 && Ymax>=0) {
					y=0;
					while((y+=Yscl)<=Ymax)
						(*_vd)->plot(&graphbm,REALX(0)+1,REALY(y),ST1);
					y=0;
					while((y-=Yscl)>=Ymin)
						(*_vd)->plot(&graphbm,REALX(0)+1,REALY(y),ST1);
				};
			} else {
				if (Ymax<=0 && Ymin>=0) {
					y=0;
					while((y+=Yscl)<=Ymin)
						(*_vd)->plot(&graphbm,REALX(0)+1,REALY(y),ST1);
					y=0;
					while((y-=Yscl)>=Ymax)
						(*_vd)->plot(&graphbm,REALX(0)+1,REALY(y),ST1);
				};
			};
		};
	mouse_show();

	(*_vd)->refresh();
}

//	Graph()
//
//	Graph all equations on the given scale.

void	Graph(void) {
	short x;

	ResetPos();

	for(x=0;x<4;x++)
		if (equ_valid[x])
			if (gc_zone2[x].flags & ZN_INVERTED)
				GraphEquation(equ_tok[x],x+1);
}

//	GraphEquation(equat,c)
//
//	Graph a specific equation in a specific color.


void	GraphEquation(short *equat,color c) {
	boolean	first_dot=TRUE;
	coord	x,ox;
	coord	y,oy;
	double	ty,pty;

	mouse_hide();
	for(x=0;x<160;x++) {
		vars['x'-'a']=GRPHX(x);
		ty=equ_eval_dbl(equat,stack,vars);
		if ((!math_error)&&!isnan(ty)) {
			pty=REALY(ty);
			if (pty<-400.0) y=-400;
			else if (pty>400.0) y=400;
			else y=pty;

			if (first_dot)
				(*_vd)->plot(&graphbm,x,y,c);
			else
				(*_vd)->line(&graphbm,ox,oy,x,y,c);
			ox=x;
			oy=y;
			first_dot=FALSE;
		} else	first_dot=TRUE;
	};
	mouse_show();
}

//	feq=FirstEquation()
//
//	Returns a pointer to the first valid tokenized function, NULL if none

short	*FirstEquation(void) {
	short x;

	for(x=0;x<4;x++)
		if (equ_valid[x]) return equ_tok[x];
	return NULL;
}

#define	FPC_LEFT	-1
#define	FPC_RIGHT	1
#define	FPC_CENTER	0
#define	FPC_TOLEFT	-2
#define	FPC_TORIGHT	2
#define	FPC_NOWHERE	10

//	cmp=FPRoot(y1,y2,y3)
//
//	Returns a comparison value to zero in on a root.

char	FPRoot(double y1,double y2,double y3) {
	if (y2<0) {
		if (y1<0) {	if (y3<0)	return FPC_NOWHERE;
				else		return FPC_RIGHT;
		} else		if (y3>0)	return FPC_NOWHERE;
				else		return FPC_LEFT;
	} else if (y2>0) {
		if (y1<0) {	if (y3<0)	return FPC_NOWHERE;
				else		return FPC_LEFT;
		} else		if (y3>0)	return FPC_NOWHERE;
				else		return FPC_RIGHT;
	} else	return FPC_CENTER;
}

//	cmp=FPMax(y1,y2,y3)
//
//	Returns a comparison value to zero in on a relative maximum.

char	FPMax(double y1,double y2,double y3) {
	if (y1>=y2 && y2>=y3) return FPC_LEFT;
	if (y3>=y2 && y2>=y1) return FPC_RIGHT;

	// y2 is greater than y1 and y3; which is greater of the two

	if (y1>y3)	return FPC_LEFT;
	else if (y1<y3)	return FPC_RIGHT;
	else		return FPC_NOWHERE;
}

//	cmp=FPMin(y1,y2,y3)
//
//	Returns a comparison value to zero in on a relative minimum.

char	FPMin(double y1,double y2,double y3) {
	if (y1<=y2 && y2<=y3) return FPC_LEFT;
	if (y3<=y2 && y2<=y1) return FPC_RIGHT;

	if (y1<y3)	return FPC_LEFT;
	else if (y1>y3)	return FPC_RIGHT;
	else		return FPC_NOWHERE;
}

//	FindPoint(func)
//
//	Find a certain point on the graph.

void	FindPoint(FindPointFunc func) {
	coord cx1,cx2;
	double x1,x2,x3,y1,y2,y3;
	short *feq;
	boolean	found;
	char	fnd;

	if (!(feq=FirstEquation())) return;

	GetXRange(&cx1,&cx2);

	x1=vars['x'-'a']=GRPHX(cx1);	y1=equ_eval_dbl(feq,stack,vars);
	x3=vars['x'-'a']=GRPHX(cx2);	y3=equ_eval_dbl(feq,stack,vars);

	TitleMessage("Press mouse button to abort...");

	found=TRUE;
	for(;;) {
		x2=vars['x'-'a']=(x1+x3)/2;	y2=equ_eval_dbl(feq,stack,vars);

		if (x1==x2 || y2==y3 || mouse_buttons()) break;

		switch(fnd=func(y1,y2,y3)) {
		case FPC_LEFT:	// within (x1-x2)
			x3=x2; y3=y2;
			break;
		case FPC_RIGHT:		// within (x2-x3)
			x1=x2; y1=y2;
			break;
		case FPC_CENTER:		// smack on the dot
			x1=x2; y1=y2;
			goto gotit;
		case FPC_TOLEFT:	// solution should appear to the left
		case FPC_TORIGHT:		// solution should appear to the right
		case FPC_NOWHERE:	// no solution in sight
			TitleMessage("Invalid range.");
			fnd=FALSE;
			goto gotit;
		};
	};
gotit:
	if (found) {
		Xpos=x1;
		Ypos=y1;
		ShiftPos(REALX(x1),REALY(y1),x1,y1);
		TitleMessage("Found a point.");
	};
}


/////////////////////// RANGE REQUESTER //////////////////////

struct Rectangle gcr_neg[]={
	{  30, 14,124, 11 },
	{  30, 27,124, 11 },
	{  30, 40,124, 11 },
	{  30, 53,124, 11 },
	{  30, 66,124, 11 },
	{  30, 79,124, 11 },
	{ RECT_END }
};

struct Rectangle gcr_pos[]={
	{  29, 13,126, 13 },
	{  29, 26,126, 13 },
	{  29, 39,126, 13 },
	{  29, 52,126, 13 },
	{  29, 65,126, 13 },
	{  29, 78,126, 13 },
	{ RECT_END }
};

struct Text gcr_text[]={
	{ "Xmin"	,  4, 15,St0,St2 },
	{ "Xmax"	,  4, 28,St0,St2 },
	{ "Ymin"	,  4, 41,St0,St2 },
	{ "Ymax"	,  4, 54,St0,St2 },
	{ "Xscl"	,  4, 67,St0,St2 },
	{ "Yscl"	,  4, 80,St0,St2 },
	{ NULL }
};

char XminBuf[20];
char XmaxBuf[20];
char YminBuf[20];
char YmaxBuf[20];
char XsclBuf[20];
char YsclBuf[20];

struct Field gcr_fld[]={
	{ 32,16,120,8,NULL,XminBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ 32,29,120,8,NULL,XmaxBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ 32,42,120,8,NULL,YminBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ 32,55,120,8,NULL,YmaxBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ 32,68,120,8,NULL,XsclBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ 32,81,120,8,NULL,YsclBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ -1,-1,-1,-1 }
};

struct Zone gcr_zone1[]={
	{ 4, 95,152, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Okay",NULL },
	{ -1,-1,-1,-1 },
};

struct ZoneRange gcr_zr[]={
	{ NULL,gcr_zone1,NULL,-1,ZR_TAP   ,NULL,-1,0,NULL,0 },
};

struct Requester gcr_req={
	0,0,160,110,
	REQ_BORDER+REQ_POPCEN,
	"Set Range",
	St2,
	NULL,
	gcr_fld,
	gcr_zr,
	NULL,
	gcr_pos,
	gcr_neg,
	gcr_text,
	NULL
};

void	RangeRequest(void) {
	boolean quit=FALSE;
	mouse_coord mx,my,mb;
	ulong msg;

	gcvt(Xmin,14,XminBuf);
	gcvt(Xmax,14,XmaxBuf);
	gcvt(Ymin,14,YminBuf);
	gcvt(Ymax,14,YmaxBuf);
	gcvt(Xscl,14,XsclBuf);
	gcvt(Yscl,14,YsclBuf);

	if (!OpenRequester(&gcr_req,0,0)) return;
	do {
		mouse_wait_unkey();
		mouse_wait_key();
		mouse_read2(&mx,&my,&mb);
		ClearMessage();

		switch(msg=CheckRequester(&gcr_req,mx,my,mb)) {
		case RZoneMsg(0,0):
			quit=TRUE;
			break;
		};
	} while(!quit);

	CloseRequester(&gcr_req);

	Xmin=atof(XminBuf);
	Xmax=atof(XmaxBuf);
	if (Xmin==Xmax) {
		Xmin=-10;
		Xmax=10;
	};
	Ymin=atof(YminBuf);
	Ymax=atof(YmaxBuf);
	if (Ymin==Ymax) {
		Ymin=-10;
		Ymax=10;
	};
	Xscl=fabs(atof(XsclBuf));
	Yscl=fabs(atof(YsclBuf));

	Xdif=Xmax-Xmin;
	Ydif=Ymax-Ymin;

	RedrawScale();
}


//////////////////////// FREE EVALUATION //////////////////////////


struct Rectangle gcfe_neg[]={
	{  30, 14,124, 11 },
	{  30, 27,124, 11 },
	{  30, 40,124, 11 },
	{  30, 53,124, 11 },
	{  30, 66,124, 11 },
	{ RECT_END }
};

struct Rectangle gcfe_pos[]={
	{  29, 13,126, 13 },
	{  29, 26,126, 13 },
	{  29, 39,126, 13 },
	{  29, 52,126, 13 },
	{  29, 65,126, 13 },
	{ RECT_END }
};

struct Text gcfe_text[]={
	{ "X1 ="	,  4, 15,St0,St2 },
	{ "Y4 ="	,  4, 28,St0,St2 },
	{ "Y3 ="	,  4, 41,St0,St2 },
	{ "Y2 ="	,  4, 54,St0,St2 },
	{ "Y1 ="	,  4, 67,St0,St2 },
	{ NULL }
};

struct Field gcfe_fld[]={
	{ 32,16,120,8,NULL,XminBuf,0,0,19,20,St0,St2,NULL,0,0,0 },
	{ -1,-1,-1,-1 }
};

struct Zone gcfe_zone1[]={
	{ 4, 82,152, 11,ZN_3D+ZN_TEXTRENDER,NULL,"Okay",NULL },
	{ -1,-1,-1,-1 },
};

struct ZoneRange gcfe_zr[]={
	{ NULL,gcfe_zone1,NULL,-1,ZR_TAP   ,NULL,-1,0,NULL,0 },
};

struct Requester gcfe_req={
	0,0,160,97,
	REQ_BORDER+REQ_POPCEN,
	{NULL},NULL,NULL,"Free Evaluate",
	St2,
	NULL,
	gcfe_fld,
	gcfe_zr,
	NULL,
	gcfe_pos,
	gcfe_neg,
	gcfe_text,
	NULL
};

void	FreeEvaluate(void) {
	boolean quit=FALSE;
	mouse_coord mx,my,mb;
	ulong msg;
	double xval;

	*XminBuf=*XmaxBuf=*YminBuf=*YmaxBuf=*XsclBuf=0;

	if (!OpenRequester(&gcfe_req,0,0)) return;
	do {
		mouse_wait_unkey();
		mouse_wait_key();
		mouse_read2(&mx,&my,&mb);
		ClearMessage();

		switch(msg=CheckRequester(&gcfe_req,mx,my,mb)) {
		case RZoneMsg(0,0):
			quit=TRUE;
			break;
		case REQM_FIELD+0:
			xval=atof(XminBuf);
			mouse_hide();
			if (equ_valid[0]) vid_printf6(&gcfe_req.reqbm,32,68,ST0,ST2,"%20.14g",((vars['x'-'a']=xval),equ_eval_dbl(equ_tok[0],stack,vars)));
			if (equ_valid[1]) vid_printf6(&gcfe_req.reqbm,32,55,ST0,ST2,"%20.14g",((vars['x'-'a']=xval),equ_eval_dbl(equ_tok[1],stack,vars)));
			if (equ_valid[2]) vid_printf6(&gcfe_req.reqbm,32,42,ST0,ST2,"%20.14g",((vars['x'-'a']=xval),equ_eval_dbl(equ_tok[2],stack,vars)));
			if (equ_valid[3]) vid_printf6(&gcfe_req.reqbm,32,29,ST0,ST2,"%20.14g",((vars['x'-'a']=xval),equ_eval_dbl(equ_tok[3],stack,vars)));
			mouse_show();
			break;
		};
	} while(!quit);

	CloseRequester(&gcfe_req);
}

