%{
	#include <stdio.h>
	#include <stdlib.h>
	#include <stddef.h>
	#include <math.h>

	#include "parser_t.h"
	#include "tokenize.h"

	char *equ_input;
	short *equ_output;

	#undef YY_INPUT
//	#define	YY_INPUT(buf,result,max_size)	{ int l=0; char *bf=buf; while(*bf++=*equ_input++) ++l; result=(l ? l : YY_NULL); }
	#define YY_INPUT(buf,result,max_size)	(result=((buf[0]=*equ_input) ? ++equ_input,1 : YY_NULL))
	
%}

VAR	[a-zA-Z]
DECNUM	([0-9]+)|([0-9]*"."[0-9]+)
EXPNUM	{DECNUM}"E"{DECNUM}

%%

","	return ',';
"+"	return '+';
"-"	return '-';
"*"	return '*';
"/"	return '/';
"-"	return '-';
"^"	return '^';
"!"	return '!';
"("	return '(';
")"	return ')';
"="	return '=';
":"	return ':';
"=="	return EQUAL;
"<"	return LESS;
">"	return GRTR;
"<="	return LESSEQ;
">="	return GRTREQ;

"sin"		return SINE;
"cos"		return COSINE;
"tan"		return TANGENT;
"sec"		return SECANT;
"csc"		return COSECANT;
"cot"		return COTANGENT;
"asin"		return ARC_SINE;
"acos"		return ARC_COSINE;
"atan"		return ARC_TANGENT;
"asec"		return ARC_SECANT;
"acsc"		return ARC_COSECANT;
"acot"		return ARC_COTANGENT;

"rec("		return POL_TO_REC;
"pol("		return REC_TO_POL;

"log"		return LOG;
"clog"		return CLOG;
"exp"		return EXP;
"sqrt"		return SQRT;
"pi"		return PI;
"syn"		return SYNEVAL;

"int"		return INT;
"abs"		return ABS;

{VAR}		{
			yylval.var=toupper(yytext[0])-'A';
			return VAR;
		}

{DECNUM}	{
			yylval.val=atof(yytext);
			return VALUE;
		}

" " |
"\n" |
"\t"

.	return FLEXERR;

%%

char *equ_scan(char *eqtn,short *tokmem) {
	char yyp;

	equ_input=eqtn;
	equ_output=tokmem;

	yyp=!!yyparse();
	evat(EVAL_END);

	yyrestart(stdin);

	if (yyp) return NULL; else return tokmem;
}

void yyerror(char *x) {
	x=x;
}

