#ifndef	VGAPAINT_LOADLIB_H
#define	VGAPAINT_LOADLIB_H

#include <a/types.h>

#include "list.h"

//typedef	void	(*vfptr)(void);

struct ExeInfo {
	vfptr	start;
	void	*memory;
};

enum ExtCommand {
	EC_STARTUP=0,		// auto-run after load & relocate - GUI may not be running!!!
	EC_INITIALIZE,		// may be called for manually loaded extensions after parent does things for extension
	EC_GUIRUNNING,		// for autoload extensions, this is called after the GUI is up and running
	EC_SUSPEND,		// prepare extension for system disruption (DOS shell, module functions) - maybe!
	EC_RESUME,		// resume operations after system disruption - maybe!
	EC_GUISHUTDOWN,		// for autoload extensions, this is called immediately before the GUI goes bye-bye
	EC_SHUTDOWN,		// may be called before unload_extension() for manually loaded extensions
	EC_CLEANUP,		// called immediately before extension is purged
				// WARNING: EC_CLEANUP may NOT return a failure value for autoload extensions!
	EC_ABOUT,		// Display your <about> requester on screen - returns 1 if ok, 0 if no about req.
	EC_SETUP,		// Display your <setup> requester on screen - returns 1 if ok, 0 if no about req.
	EC_STARTUP1,		// called immediately after EC_STARTUP tag -- variables are passed correctly here
};

typedef	long	(*ExtEntry)(struct Extension *ext,enum ExtCommand command,long xval,long yval);

struct Extension {
	struct	Node	user;		// useable by Extension loader - used by Autoloader for autoload ext chain
	struct	Node	node;		// link into global Extension chain
	struct	ExeInfo	ei;
	ExtEntry	entry;		// entry pointer to extension
	ushort		usecount;	// number of times this extension is in use
	char *		name;		// the "name" of this extension, which shows up in the dialogue box
};

boolean load_pharlap(char *name,struct ExeInfo *ei);
void	unload_pharlap(struct ExeInfo *ei);
long	run_pharlap(struct ExeInfo *ei);
void	revector_pharlap(struct ExeInfo *ei,ulong *reloclst);

boolean			run_extension(char *extname);
struct Extension *	load_extension(char *extname);
boolean			unload_extension(struct Extension *ext);
boolean			announce_to_extensions(struct List *extension_list,enum ExtCommand command,long xval,long yval);
void			unload_extensions(struct List *extension_list);

void	ExtensionDisplayInfoList(void);

#endif
