#define	VGAPAINT_MENU_C
#include "menu.h"
#include "vgapaint.h"
#include "toolicon.h"

#include <stdarg.h>

static int menulevel;
static struct Rectangle _boxrect[9];

struct Menu *MenuListIndex(struct Menu *first,int index) {
	struct Menu *next;

	while(first && index--) {
		next = (struct Menu *)first->node.next;
		if (next == (void *)-1L) ++first; else first=next;
	}
	return first;
}

void DisplayMenuBar(struct Menu *mn) {
	BLOCK bl;
	struct Rectangle mainrect={ 0,0,320,11 };
	struct Rectangle itemrect,*itemrects,*tmp;
	int count=(int)mn->name;
	struct Menu *mi,*minext;
	mouse_coord x,y,b;
	int rect;
	int lasthigh=-1;

	if (!(itemrects=malloc(sizeof(struct Rectangle)*(count+1)))) return;
	itemrects[count].x=RECT_END;

	menulevel=1;

	mainrect.width = vidbm.width;
	mainrect.height = sysfontheight+4*YPOINT-1;

	mouse_hide();
	bl=vd->blocksave(&vidbm,0,0,mainrect.width,mainrect.height);
	vd->bar(&vidbm,0,0,mainrect.width,mainrect.height,ST2);

	tmp=itemrects;
	mi=mn; minext = (struct Menu *)mi->node.next; if (minext == (void *)-1L) ++mi; else mi=minext;
	x=2; y=2*YPOINT-1;
	while(count--) {
		tmp->x=x;
		tmp->y=0;

		SysText(&vidbm,x+6,y,mi->name,mi->flags & MF_DISABLED ? ST1 : ST0,ST2);
		x+=(tmp->width=SysTextLength(mi->name)+12);
		tmp->height=mainrect.height;
		++tmp;
		minext = (struct Menu *)mi->node.next;
		if (minext == (void *)-1L) ++mi; else mi=minext;
	};

	vd->refresh();
	mouse_show();

	choice[0]=-1;

	for(;;) {
		kbd_check();
		mouse_read2(&x,&y,&b);
		if (!b) break;

		rect=rectSearch(itemrects,x,y);
		if (rect!=lasthigh) {
			if (lasthigh>=0) {
				mouse_hide();
				vd->bar(&vidbm,itemrects[lasthigh].x,itemrects[lasthigh].y,itemrects[lasthigh].width,
					itemrects[lasthigh].height,0x80000000L+STI);
				mouse_show();
			};
			choice[0]=lasthigh=rect;
			if (rect!=-1) {
				mouse_hide();
				vd->bar(&vidbm,itemrects[lasthigh].x,itemrects[lasthigh].y,itemrects[lasthigh].width,
					itemrects[lasthigh].height,0x80000000L+STI);
				vd->refresh();
				mouse_show();
				itemrect.x=itemrects[rect].x;
				itemrect.y=itemrects[rect].y;
				itemrect.width=itemrects[rect].width;
				itemrect.height=itemrects[rect].height;
				last_choice = MenuListIndex(mn+1,rect);
				if (last_choice->first)
					DisplayMenu(last_choice,&itemrect,&mainrect,MP_DOWN);
			};
		};
	};

	mouse_hide();
	vd->blockrestore(&vidbm,bl);
	vd->refresh();
	mouse_show();
}

void PopupMenu(struct Menu *mn,struct Rectangle *rect,int placement) {
	struct Menu m;

	menulevel=1;
	m.first=mn;
	DisplayMenu(&m,rect,rect,placement);
}

void DisplayMenu(struct Menu *mn,struct Rectangle *rect,struct Rectangle *oldrect,int placement) {
	struct Rectangle boxrect,itemrect,highrect;
	struct Menu *mi,*minext,*fmi;
	int	cnt;
	int	len,items=0;
	BLOCK	bl;
	int	lasthigh=-1;
	int	x,y;
	mouse_coord mx,my,b;
	boolean greyflag=FALSE;
	ulong	disabled_flags;


	if (opt.debugOpts) disabled_flags = MF_DISABLED; else disabled_flags = MF_DISABLED+MF_DEBUG;


	_boxrect[menulevel-1]=*oldrect;
	_boxrect[menulevel].x=RECT_END;

	boxrect.width=0;

	mi=mn->first;

	while(mi) {
		len=4*vdrv_cur->x_aspect + SysTextLength(mi->name);
		if (mi->first) len+=10;
		if (mi->auxname)	len+=(12+SysTextLength(mi->auxname));
		if (len>boxrect.width) boxrect.width=len;
		minext = (struct Menu *)mi->node.next;
		if (minext == (void *)-1L) ++mi; else mi=minext;
		++items;
	};
	boxrect.height=items*sysfontheight+4*vdrv_cur->y_aspect;

	boxrect.x=rect->x;
	boxrect.y=rect->y-2*vdrv_cur->y_aspect;

	switch(placement) {
	case MP_DOWN:
		boxrect.y+=rect->height+YPOINT;
		break;
	case MP_RIGHT:

		// if there is no room on the right, place it on the left

		if (vidbm.width - boxrect.width < rect->x + rect->width/4) {
			placement = MP_LEFT;
			++boxrect.x;
			break;
		}

		boxrect.x+=(rect->width-4*vdrv_cur->x_aspect);
		break;
	case MP_LEFT:
		break;
	}

	if (placement == MP_LEFT)
		boxrect.x -= boxrect.width-1;

	if (boxrect.x<0) boxrect.x=0;
	if (boxrect.y<0) boxrect.y=0;
	if (boxrect.width>vidbm.width) boxrect.width=vidbm.width;
	if (boxrect.height>vidbm.height) boxrect.height=vidbm.height;
	if ((boxrect.x+boxrect.width)>vidbm.width) boxrect.x=vidbm.width-boxrect.width;
	if ((boxrect.y+boxrect.height)>vidbm.height) boxrect.y=vidbm.height-boxrect.height;

	highrect.x	= boxrect.x+2*vdrv_cur->x_aspect;
	highrect.y	= boxrect.y+2*vdrv_cur->y_aspect;
	highrect.width	= boxrect.width-4*vdrv_cur->x_aspect;
	highrect.height	= boxrect.height-4*vdrv_cur->y_aspect;

	mouse_hide();
	bl=vd->blocksave(&vidbm,boxrect.x,boxrect.y,boxrect.width,boxrect.height);
	vd->bar(&vidbm,boxrect.x,boxrect.y,boxrect.width,boxrect.height,ST2);
	vid_draw3d(&vidbm,boxrect.x,boxrect.y,boxrect.x+boxrect.width-1,boxrect.y+boxrect.height-1);

	mi=mn->first;
	y=highrect.y;
	for (cnt=items;cnt;cnt--) {
		SysText(&vidbm,highrect.x,y,mi->name,mi->flags & disabled_flags ?ST1:ST0,ST2);
		if (mi->auxname)
			SysText(&vidbm,highrect.x+highrect.width-SysTextLength(mi->auxname),y,mi->auxname,
				mi->flags & disabled_flags ? ST1 : ST3,ST2);
		if (mi->first)
			vd->bltpattern(&vidbm,triright,highrect.x+highrect.width-4*vdrv_cur->x_aspect,y,4,7,ST0,ST2);
		y+=sysfontheight;
		minext = (struct Menu *)mi->node.next;
		if (minext == (void *)-1L) ++mi; else mi=minext;
	};
	vd->refresh();
	mouse_show();

	fmi=mn->first;
	choice[menulevel]=-1;
	choice[menulevel+1]=-1;

	for (;;) {
		kbd_check();
		mouse_read2(&mx,&my,&b);
		if (!b) break;

		x=mx; y=my;

		if ((x-=highrect.x)>=0 && (y-=highrect.y)>=0)
			if (x<highrect.width && y<highrect.height) {
				y/=sysfontheight;
				if (lasthigh!=y) {
					mi = MenuListIndex(fmi,y);
					if (lasthigh>=0) {
						mouse_hide();
						vd->bar(&vidbm,highrect.x,highrect.y+(lasthigh*sysfontheight),highrect.width,sysfontheight,0x80000000+STI);
						mouse_show();
					};
					if (mi->flags & disabled_flags) { /* if greyed don't display */
						lasthigh=-1;
						vd->refresh();
						mouse_show();
						greyflag=TRUE;
						goto greyed;
					};
					last_choice = mi;
					lasthigh=y;
					mouse_hide();
					vd->bar(&vidbm,highrect.x,highrect.y+(y*sysfontheight),highrect.width,sysfontheight,0x80000000+STI);
					vd->refresh();
					mouse_show();
					choice[menulevel]=y;
					if (mi->first) {
						itemrect.x=highrect.x;
						itemrect.y=highrect.y+(y*sysfontheight);
						itemrect.width=highrect.width;
						itemrect.height=sysfontheight;
						++menulevel;
						DisplayMenu(mi,&itemrect,&boxrect,MP_RIGHT);
						--menulevel;
					};
				};
				continue;	/* skip exit check */
			};

greyed:
		choice[menulevel]=-1;

		if (lasthigh>=0) {
			mouse_hide();
			vd->bar(&vidbm,highrect.x,highrect.y+(lasthigh*sysfontheight),highrect.width,sysfontheight,0x80000000+STI);
			vd->refresh();
			lasthigh=-1;
			mouse_show();
		};

		if (greyflag) { greyflag=FALSE; continue; };

		if (rectInside(rect,mx,my)) continue;

		if (oldrect)
			if (-1!=rectSearch(_boxrect,mx,my)) break;
	};

	mouse_hide();
	vd->blockrestore(&vidbm,bl);
	vd->refresh();
	mouse_show();

	_boxrect[menulevel-1].x=RECT_END;	
}

struct Menu loadmenu[]={
	{	MN_START,NULL	,"Autodetect"		,"PgDn"	},
	{	MN_INIT ,NULL	,"PCX Compressed"	,NULL	},
	{	MN_INIT	,NULL	,"PAK (Raw data)"	,"Shift-PgDn" },
	{	MN_INIT	,NULL	,"IFF (ILBM/ACBM/PBM)"	,"CSh-PgUp"	},
	{	MN_INIT	,NULL	,"PAL (8-bit Palette)"	,NULL	},
	{	MN_END	,NULL	,"BMP (256c, uncomp)"	,NULL	},
};

struct Menu savemenu[]={
	{	MN_START,NULL	,"PCX-8 Compressed"	,"PgUp"	},
	{	MN_INIT	,NULL	,"PCX-4 Compressed"	,NULL	},
	{	MN_INIT	,NULL	,"COM Program"		,"Ctrl-PgUp"	},
	{	MN_INIT	,NULL	,"PAK (Raw data)"	,"Shift-PgUp"	},
	{	MN_INIT	,NULL	,"IFF (ILBM/ACBM/PBM)"	,"CSh-PgUp"	},
	{	MN_INIT	,NULL	,"BMP (256c, uncomp)"	,"Alt-PgUp"	},
	{	MN_INIT	,NULL	,"PAL (8-bit Palette)"	,NULL	},
	{	MN_INIT	,NULL	,"BIN HP48 8-shade GROB",NULL	},
	{	MN_END	,NULL	,"PCX-8 SelfExtract"	,NULL	},
};

struct Menu pictfmenu[]={
	{	MN_START,NULL	,"Flip X"		,NULL	},
	{	MN_INIT	,NULL	,"Flip Y"		,NULL	},
	{	MN_END	,NULL	,"Rotate Right"		,NULL	},
};

struct Menu projmenu[]={
	{	MN_START,NULL		,"New"			,NULL	},
	{	MN_INIT	,loadmenu	,"Load"			,NULL	},
	{	MN_INIT	,NULL		,"Save"			,NULL	,MF_DISABLED	},
	{	MN_INIT	,savemenu	,"Save As..."		,NULL	},
	{	MN_INIT	,NULL		,"Bitmap Size..."	,NULL	},
	{	MN_INIT	,pictfmenu	,"Transform"		,NULL	},
	{	MN_INIT	,NULL		,"Overview"		,NULL	},
	{	MN_INIT	,NULL		,"Info"			,NULL	},
	{	MN_INIT	,NULL		,"Print..."		,NULL	},
	{	MN_INIT	,NULL		,"About"		,NULL	},
	{	MN_END	,NULL		,"Quit"			,"Esc"	},
};

struct Menu brush_colormenu[]={
	{	MN_START,NULL	,"Change Transp."	,NULL	},
	{	MN_END	,NULL	,"Remap to palette"	,NULL	},
};

struct Menu brush_orientmenu[]={
	{	MN_START,NULL	,"Flip X"		,"x"	},
	{	MN_INIT	,NULL	,"Flip Y"		,"y"	},
	{	MN_INIT	,NULL	,"Rotate Right"		,"z"	},
	{	MN_END	,NULL	,"Free rotate"		,NULL	},
};

struct Menu brush_handlemenu[]={
	{	MN_START,NULL	,"Cycle"		,"Ctrl-X"	},
	{	MN_INIT	,NULL	,"Center"		,NULL		},
	{	MN_END	,NULL	,"Place"		,"Ctrl-Z"	,MF_DISABLED },
};

struct Menu brush_sizemenu[]={
	{	MN_START,NULL	,"Halve"		,"h"		},
	{	MN_INIT	,NULL	,"Double"		,"H"		},
	{	MN_INIT	,NULL	,"Double X"		,"X"		},
	{	MN_INIT	,NULL	,"Double Y"		,"Y"		},
	{	MN_END	,NULL	,"Free scale"		,"Z"		},
};

struct Menu brushmenu[]={
	{	MN_START,NULL			,"  Matte"		,"F1"	},
	{	MN_INIT	,NULL			,"  Color"		,"F2"	},
	{	MN_INIT	,NULL			,"  Opaque"		,"F3"	},
	{	MN_INIT	,brush_colormenu	,"  Palette"		,NULL	},
	{	MN_INIT	,brush_orientmenu	,"  Orient"		,NULL	},
	{	MN_INIT	,brush_handlemenu	,"  Handle"		,NULL	},
	{	MN_END	,brush_sizemenu		,"  Resize"		,NULL	},
};

struct Menu dithermenu[]={
	{	MN_START,NULL		,"640x480 16-color"	,NULL	},
	{	MN_INIT	,NULL		,"1x1x1 RGB"		,NULL	},
	{	MN_END	,NULL		,"640x480 2-color"	,NULL	},
};

struct Menu processmenu[]={
	{	MN_START,NULL		,"3x3 Average RGB"	,NULL	},
	{	MN_INIT	,NULL		,"5x5 Average RGB"	,NULL	},
	{	MN_INIT	,NULL		,"3x3 Median RGB"	,NULL	},
	{	MN_INIT	,NULL		,"Invert"		,NULL	},
	{	MN_INIT	,NULL		,"Colors most->least"	,NULL	},
	{	MN_INIT	,NULL		,"Colors least->most"	,NULL	},
	{	MN_INIT	,NULL		,"Merge Same Colors"	,NULL	},
	{	MN_INIT	,NULL		,"PCX Optimize"		,NULL	},
	{	MN_INIT	,NULL		,"Delta Horizontally"	,NULL	},
	{	MN_INIT	,NULL		,"Delta Vertically"	,NULL	},
	{	MN_INIT	,NULL		,"Un-delta Horiz"	,NULL	},
	{	MN_END	,NULL		,"Un-delta Vert"	,NULL	},
};

struct Menu prepicmenu[]={
	{	MN_START,NULL		,"Color chart"		,NULL	},
	{	MN_INIT	,NULL		,"RGB Bars"		,NULL	},
	{	MN_INIT	,NULL		,"Rainbows"		,NULL	},
	{	MN_INIT	,NULL		,"Plasma 1"		,NULL	},
	{	MN_INIT	,NULL		,"Gamma Test"		,NULL	},
	{	MN_INIT	,NULL		,"Gamma Test 2"		,NULL	},
	{	MN_INIT	,NULL		,"Maze"			,NULL	},
	{	MN_END	,NULL		,"Std. Palette"		,NULL	},
};

struct Menu sparemenu[]={
	{	MN_START,NULL		,"New"			,NULL	},
	{	MN_INIT	,NULL		,"Swap"			,"j"	},
	{	MN_INIT	,NULL		,"Copy from spare"	,"Ctrl-J"	},
	{	MN_INIT	,NULL		,"Spare list..."	,"Alt-J"	},
	{	MN_INIT	,NULL		,"Get palette"		,NULL	},
	{	MN_INIT	,NULL		,"Fit to palette"	,NULL	},
	{	MN_INIT	,NULL		,"Merge"		,NULL	},
	{	MN_INIT	,NULL		,"Delete"		,NULL	},
	{	MN_INIT	,NULL		,"Underlay"		,NULL	},
	{	MN_END	,NULL		,"Overlay"		,NULL	},
};

struct Menu tonemenu[]={
	{	MN_START,NULL		,"Brightness..."	,"F8"	},
	{	MN_INIT	,NULL		,"Color balance..."	,"Shift-F8"	},
	{	MN_END	,NULL		,"Color control..."	,NULL	},
};

struct Menu convertmenu[]={
	{	MN_START,NULL		,"Grey scale"	,NULL	},
	{	MN_INIT	,NULL		,"Black & White",NULL	},
	{	MN_INIT	,NULL		,"Grey pal(256)",NULL	},
	{	MN_INIT	,NULL		,"Grey pal( 64)",NULL	},
	{	MN_INIT	,NULL		,"Grey pal( 16)",NULL	},
	{	MN_END	,NULL		,"Grey pal(  8)",NULL	},
};

struct Menu rangemenu2[]={
	{	MN_START,NULL		,"* Range 1"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 2"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 3"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 4"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 5"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 6"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 7"	,NULL	},
	{	MN_END	,NULL		,"  Range 8"	,NULL	},
};

struct Menu fillmenu[]={
	{	MN_START,NULL		,"* Normal"		,NULL	},
	{	MN_INIT	,NULL		,"  Tile"		,NULL	},
	{	MN_INIT	,NULL		,"  Stretch"		,NULL	},
	{	MN_INIT	,NULL		,"  Stretch/blend"	,NULL	},
	{	MN_INIT	,NULL		,"  Horizontal"		,NULL	,MF_DISABLED	},
	{	MN_INIT	,NULL		,"  Vertical"		,NULL	,MF_DISABLED	},
	{	MN_INIT	,NULL		,"  Horiz Gradient"	,NULL	},
	{	MN_INIT	,NULL		,"  Vert Gradient"	,NULL	},
	{	MN_END	,rangemenu2	,"Color Range"		,NULL	},
};

struct Menu rangemenu[]={
	{	MN_START,NULL		,"* Range 1"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 2"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 3"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 4"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 5"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 6"	,NULL	},
	{	MN_INIT	,NULL		,"  Range 7"	,NULL	},
	{	MN_END	,NULL		,"  Range 8"	,NULL	},
};

struct Menu drawmenu[]={
	{	MN_START,NULL		,"* Normal"	,NULL	},
	{	MN_INIT	,NULL		,"  Range-forward",NULL	},
	{	MN_INIT	,NULL		,"  Range-backward",NULL},
	{	MN_END	,rangemenu	,"Color range"	,NULL	},
};

struct Menu linemenu[]={
	{	MN_START,NULL		,"* Normal"	,NULL	},
	{	MN_INIT	,NULL		,"  Antialias"	,NULL	},
	{	MN_END	,NULL		,"  Antialias/Blend",NULL	},
};

struct Menu blitmenu[]={
	{	MN_START,NULL		,"* Normal"	,NULL	},
	{	MN_INIT	,NULL		,"  Add"	,NULL	},
	{	MN_INIT	,NULL		,"  Transparent",NULL	},
	{	MN_END	,NULL		,"  Shade"	,NULL	},
};

struct Menu animload_menu[]={
	{	MN_START,NULL		,"VP386 Format (.van)"	,NULL	},
	{	MN_INIT	,NULL		,"Multiple PCX (.pcx)"	,NULL	},
	{	MN_END	,NULL		,"AVI          (.avi)"	,NULL	},
};

struct Menu animsave_menu[]={
	{	MN_START,NULL		,"VP386 Format (.van)"		,NULL	},
	{	MN_INIT	,NULL		,"VP386 Format w/audio (.van)"	,NULL	},
	{	MN_INIT	,NULL		,"Multiple PCX (.pcx)"		,NULL	},
	{	MN_INIT	,NULL		,"Windows cursor (.ani)"	,NULL	},
	{	MN_INIT	,NULL		,"VP386 Temporal 1 (.van)"	,NULL	},
	{	MN_INIT	,NULL		,"VP386 Temporal 1A (.van)"	,NULL	},
	{	MN_INIT	,NULL		,"VP386 Delta2-Huffman (.van)"	,NULL	},
	{	MN_END	,NULL		,"Uncompressed Flic (.flc)"	,NULL	},
};

struct Menu animfpal_menu[]={
	{	MN_START,NULL		,"Attach From Prev"	,NULL	},
	{	MN_INIT	,NULL		,"Attach From Next"	,NULL	},
	{	MN_INIT	,NULL		,"Attach New"		,NULL	},
	{	MN_INIT	,NULL		,"Detach"		,NULL	},
	{	MN_INIT	,NULL		,"Detach All"		,NULL	},
	{	MN_END	,NULL		,"Separate"		,NULL	},
};

struct Menu animproc_menu[]={
	{	MN_START,NULL		,"Feather palettes"	,NULL	},
	{	MN_END	,NULL		,"Align palettes"	,NULL	,MF_DEBUG	},
};

struct Menu animmenu[]={
	{	MN_START,animload_menu	,"Load Anim"		,NULL	},
	{	MN_INIT	,animsave_menu	,"Save Anim"		,NULL	},
	{	MN_INIT	,NULL		,"Prev Frame"		,"1"	},
	{	MN_INIT	,NULL		,"Next Frame"		,"2"	},
	{	MN_INIT	,NULL		,"Goto Frame"		,"3"	},
	{	MN_INIT	,NULL		,"Forward Play"		,"4"	},
	{	MN_INIT	,NULL		,"Play Once"		,"5"	},
	{	MN_INIT	,NULL		,"Ping-pong"		,"6"	},
	{	MN_INIT	,NULL		,"Add Frame Before"	,"!"	},
	{	MN_INIT	,NULL		,"Add Frame After"	,"@"	},
	{	MN_INIT	,NULL		,"Delete Frame"		,"#"	},
	{	MN_INIT	,NULL		,"Set Playback Rate..."	,NULL	},
	{	MN_INIT	,animfpal_menu	,"Frame Palette"	,NULL	},
	{	MN_INIT	,NULL		,"Edit Anim Palette..."	,NULL	},
	{	MN_END	,animproc_menu	,"Process"		,NULL	},
};

struct Menu tilemenu[]={
	{	MN_START,NULL		,"  Enabled"		,NULL	},
	{	MN_END	,NULL		,"Make Tile Grid"	,NULL	,MF_DISABLED	},
};

struct Menu specialmenu[]={
	{	MN_START,NULL		,"Palette..."	,"p"	},
	{	MN_INIT	,NULL		,"Arrange..."	,"P"	},
	{	MN_INIT	,NULL		,"Ranges..."	,"Ctrl-R"	},
	{	MN_INIT	,dithermenu	,"Dither"	,NULL	},
	{	MN_INIT	,processmenu	,"Process"	,NULL	},
	{	MN_INIT	,prepicmenu	,"Pre-pics"	,NULL	},
	{	MN_INIT	,sparemenu	,"Spare"	,NULL	},
	{	MN_INIT	,tonemenu	,"Tone"		,NULL	},
	{	MN_INIT	,convertmenu	,"Convert"	,NULL	},
	{	MN_INIT	,fillmenu	,"Fill mode"	,NULL	},
	{	MN_INIT	,drawmenu	,"Draw mode"	,NULL	},
	{	MN_INIT	,linemenu	,"Line mode"	,NULL	},
	{	MN_INIT	,blitmenu	,"Blit mode"	,NULL	},
	{	MN_END	,tilemenu	,"Tile mode"	,NULL	},
};

struct Menu sizemenu[]={
	{	MN_START,NULL	,"* 400 lines (1.11:1)"	,NULL	},
	{	MN_INIT	,NULL	,"  350 lines (1.28:1)"	,NULL	},
	{	MN_END	,NULL	,"  480 lines (1.00:1)"	,NULL	},
};

struct Menu monitormenu[]={
	{	MN_START,NULL	,"  Use Adjustment"	,NULL	},
	{	MN_END	,NULL	,"  Gamma..."		,NULL	},
};

struct Menu scrollmenu[]={
	{	MN_START,NULL	,"* Mouse mode"		,NULL	},
	{	MN_INIT	,NULL	,"  Tablet mode"	,NULL	},
	{	MN_END	,NULL	,"Scroll speed..."	,NULL	},
};

struct Menu savesetmenu[]={
	{	MN_START,NULL	,"Preferences"		,NULL	},
	{	MN_INIT	,NULL	,"Video Mode"		,NULL	},
	{	MN_END	,NULL	,"Picture size"		,NULL	},
};

struct Menu reduceplacemodemenu[]={
	{	MN_START,NULL	,"* Top"		,NULL	},
	{	MN_END	,NULL	,"  Bottom"		,NULL	},
};

struct Menu reducedithermodemenu[]={
	{	MN_START,NULL	,"* None"		,NULL	},
	{	MN_INIT	,NULL	,"  Fine"		,NULL	},
	{	MN_INIT	,NULL	,"  Coarse"		,NULL	},
	{	MN_END	,NULL	,"  Floyd-Steinberg"	,NULL	},
};

struct Menu reducemodemenu[]={
	{	MN_START,NULL	,"Max colors..."	,NULL	},
	{	MN_INIT	,reducedithermodemenu	," Dither"		,NULL	},
	{	MN_INIT	,reduceplacemodemenu	,"Color placement"	,NULL	},
	{	MN_INIT	,NULL	,"* Adaptive"		,NULL	},
	{	MN_INIT	,NULL	,"  6x7x6A"		,NULL	},
	{	MN_INIT	,NULL	,"  6x7x6"		,NULL	},
	{	MN_END	,NULL	,"  6x6x6"		,NULL	},
};

struct Menu prefsmenu[]={
	{	MN_START,NULL		,"  Video Driver..."	,NULL	},
	{	MN_INIT	,NULL		,"  Capture Mode..."	,NULL	},
	{	MN_INIT	,NULL		,"  Repeat Draw"	,"Ctrl"	},
	{	MN_INIT	,NULL		,"  Coordinates"	,"|"	},
	{	MN_INIT	,NULL		,"* Aspect Ratio"	,NULL	},
	{	MN_INIT	,NULL		,"  Autotransparency"	,NULL	},
	{	MN_INIT	,NULL		,"  Adjust Brush Pick"	,NULL	},
	{	MN_INIT	,NULL		,"  No-flicker Brush"	,NULL	},
	{	MN_INIT	,NULL		,"  Use Hires Tools"	,NULL	},
	{	MN_INIT	,NULL		,"  Hog CPU Time"	,NULL	},
	{	MN_INIT	,NULL		,"  Half Screen"	,NULL	},
	{	MN_INIT	,sizemenu	,"  Screen Density"	,NULL	},
	{	MN_INIT	,monitormenu	,"  Monitor Adjust"	,NULL	},
	{	MN_INIT	,scrollmenu	,"  Scroll Mode"	,NULL	},
	{	MN_INIT	,NULL		,"  Fast Preview"	,NULL	},
	{	MN_INIT	,savesetmenu	,"  Save Settings"	,NULL	},
	{	MN_END	,reducemodemenu	,"  Reduction Mode"	,NULL	},
};

struct Menu extnmenu[]={
	{	MN_START,NULL	,"Extensions..."	,NULL	},
	{	MN_END	,NULL	,"Run Module..."	,NULL	},
};

struct Menu barmenu[]={
	{	MN_START,NULL,(char *)7,NULL },	/* dummy entry */
	{	MN_START,projmenu	,"Project"	,NULL	},
	{	MN_INIT	,brushmenu	,"Brush"	,NULL	},
	{	MN_INIT	,animmenu	,"Anim"		,NULL	},
	{	MN_INIT	,specialmenu	,"Special"	,NULL	},
	{	MN_INIT	,prefsmenu	,"Prefs"	,NULL	},
	{	MN_INIT	,extnmenu	,"Ext"		,NULL	},
	{	MN_END	,NULL		,"Help"		,NULL	},
};

boolean menu_toggle(void) {
	struct Menu *mnext,*menu = barmenu+1;
	int	i=1,j=choice[0];

	while(menu && j != -1) {
		while(menu && j--) {
			mnext = (struct Menu *)menu->node.next;
			if (mnext == (void *)-1L) ++menu; else menu=mnext;
		}
		j=choice[i++];
		if (j!=-1) menu=menu->first;
	};

	if (menu)
		return (*menu->name^=('*' ^ ' '))=='*';
	else
		return FALSE;
}

void	menu_choose(struct Menu *mn,long start,long num,long current) {
	struct Menu *next;

	if (current==-1) return;
	mn+=start;
	while(num-- && mn) {
		if (mn->name[0] != '!')
			mn->name[0]=(start==current)?'*':' ';
		++start;
		next = (struct Menu *)mn->node.next;
		if (next == (void *)-1L) ++mn; else mn=next;
	};
}

void	menu_pick(long n1, ...) {
	va_list val;
	int i=1;

	choice[0]=n1;
	va_start(val,n1);
	while((choice[i++]=va_arg(val,int))!=-1);
	va_end(val);

	MenuPick();
}

struct Menu *menu_item_address(struct Menu *menu,long n1, ...) {
	struct Menu *mnext;
	va_list val;

	va_start(val,n1);
	while(n1 != -1) {
		if (n1 == -2) // last item
			for(;;) {
				mnext = (struct Menu *)menu->node.next;
				if (mnext == (void *)-1L) ++menu;
				else if (mnext) menu=mnext; else break;
			}
		else
			while(menu && n1--) {
				mnext = (struct Menu *)menu->node.next;
				if (mnext == (void *)-1L) ++menu; else menu=mnext;
			}
		n1 = va_arg(val,int);
		if (n1!=-1) menu=menu->first;
	};
	va_end(val);

	return menu;
}

int	menu_add_to_end(struct Menu *menu,struct Menu *new) {		// returns index
	struct Menu *mnext;

	int i=1;

	for(;;) {
		mnext = (struct Menu *)menu->node.next;
		if (mnext == (void *)-1L) ++menu;
		else if (mnext) menu=mnext; else break;
		++i;
	};

	menu->node.next = &new->node;
	new->node.prev = &menu->node;

	return i;
}

void	menu_set_toggle_option(struct Menu *menu,boolean newstate) {
	menu->name[0] = newstate ? '*' : ' ';
}
