//////////////////////////////////////////////////////
//
// VGAPaint 386 - menupick.c
//
// Routines for handling picks from main VP386 menu.
//

#include <a/bits.h>

#include "vgapaint.h"
#include "info.h"
#include "loadlib.h"
#include "menu.h"
#include "file.h"
#include "pcx.h"
#include "io.h"
#include "picture.h"
#include "anim.h"
#include "animio.h"
#include "inifile.h"

extern struct Menu sizemenu[];
extern struct Menu blitmenu[];
extern struct Menu scrollmenu[];
extern struct Menu reducemodemenu[];
extern struct Menu reduceplacemodemenu[];
extern struct Menu reducedithermodemenu[];

struct CallList menupickers;

void	FileIORespond(enum PictureIOErrors pioe) {
	switch(pioe) {
	case PIOERR_NONE:	break;
	case PIOERR_ABORT_USER:	break;
	case PIOERR_OPEN:	Message("Failure opening file."); break;
	case PIOERR_READ:	Message("Failure reading file."); break;
	case PIOERR_WRITE:	Message("Failure writing file."); break;
	case PIOERR_BADFORMAT:	Message("Bad format reading file."); break;
	case PIOERR_NONAME:	break;
	case PIOERR_BADSIZE:	Message("Incorrect picture size!"); break;
	case PIOERR_UNKNOWN:	Message("Unknown error loading file."); break;
	case PIOERR_MEMORY:	Message("Not enough memory."); break;
	}
}

void MenuPick(void) {
	ExecuteCallList(&menupickers,choice);
	switch(choice[0]) {
	case 0:	/* project */
		switch(choice[1]) {
		case 1: /* load */
			if (pict_cur->flags & PICT_HASNAME) SetPrevName(pict_cur->name);
			switch(choice[2]) {
			case 0: PictureLoad(); break;
			case 1: PCXRead(GetFileName("Load PCX File","pcx"),2); break;
			case 2: Raw256_Extract(GetFileName("Extract Raw Data","pak")); break;
			case 3:	IFFRead(GetFileName("Load IFF File","lbm")); break;
			case 4:	FileIORespond(PALRead(GetFileName("Load PAL File","pal"))); break;
			case 5: FileIORespond(BMPRead(GetFileName("Load BMP File","bmp"))); break;
			}; break;
		case 3: /* save as */
			SetPrevName(pict_cur->name);
			switch(choice[2]) {
			case 0: FileIORespond(PCXWrite	  (GetFileNameSave("Save PCX-8 File","pcx"),picbm,pict_cur->cur_pal)); break;
			case 1: FileIORespond(PCXWrite4   (GetFileNameSave("Save PCX-4 File","pcx"),picbm)); break;
			case 2: FileIORespond(PCXCom_Write(GetFileNameSave("Save COM File","com"),picbm)); break;
			case 3: FileIORespond(Pak_Dump	  (GetFileNameSave("Save Raw Data","pak"),picbm)); break;
			case 4:	FileIORespond(IFFWrite	  (GetFileNameSave("Save IFF File","lbm"),picbm)); break;
			case 5:	FileIORespond(BMPWrite	  (GetFileNameSave("Save BMP File","bmp"),picbm)); break;
			case 6: FileIORespond(PALWrite	  (GetFileNameSave("Save PAL File","pal"),picbm)); break;
			case 7:	FileIORespond(HP48Write3  (GetFileNameSave("Save HP48 File","bin"),picbm)); break;
			case 8: FileIORespond(PCXWriteSFX (GetFileNameSave("Save PCX-Sfx File","pcx"),picbm)); break;
			}; break;
		case 4:	/* scrsize */
			ScrSizeReq();
			break;
		case 5:	// transform
			switch(choice[2]) {
			case 0: pic_flip_x();		break;
			case 1: pic_flip_y();		break;
			case 2: pic_rotate_right();	break;
			};

			if (choice[2]) {
				restore_screen();
				PictureMarkDirty(pict_cur);
			}
			break;
		case 6:	/* overview */
			Overview(); break;
		case 7: /* info */
			Info(); break;
		case 8:	/* print */
			Print(); break;
		case 9:	/* about */
			About(); break;
		case 10: /* quit */
			quit=(RequestBoolean("VP386 Warning","Yes",NULL,"No","Quit this great program?")==2);
			break;
		}; break;
	case 1:	/* brush */
		switch(choice[1]) {
		case 0:	BrushMode(0); break;
		case 1: BrushMode(1); break;
		case 2: BrushMode(2); break;
		case 3:	switch(choice[2]) {
			case 0:	/* change transparency */
				OffBrush();
				brush_sprite.trans_colr=bcolor;
				break;
			case 1: /* remap to current palette */
				brush_remap();
				break;
			}; break;
		case 4:	switch(choice[2]) {
			case 0: /* flip x */
				brush_flipx();
				break;
			case 1: /* flip y */
				brush_flipy();
				break;
			case 2: /* rotate right */
				brush_rotright();
				break;
			case 3: /* free rotate */
				brush_free_rotate();
				break;
			}; break;
		case 5:	switch(choice[2]) {
			case 0: /* cycle */
				brush_handle_cycle();
				break;
			case 1: /* center */
				brush_handle_center();
				break;
			case 2: /* place */
				break;
			}; break;
		case 6:	switch(choice[2]) {
			case 0:	/* halve */
				brush_halve();
				break;
			case 1: /* double */
				brush_double();
				break;
			case 2: /* doubleX */
				brush_double_x();
				break;
			case 3: /* doubleY */
				brush_double_y();
				break;
			case 4:	/* freescale */
				brush_scale();
				break;
			}; break;
		}; break;
	case 2:	// anim
		switch(choice[1]) {
		case 0:	// load
			switch(choice[2]) {
			case 0:	FileIORespond(AnimReadVP(pict_cur,GetFileName("Load VP386 Anim","van"),FALSE));
				restore_screen(); break;
			case 1:	FileIORespond(AnimReadPCX(pict_cur,GetFileName("Load PCX Sequence","pcx"),FALSE));
				restore_screen(); break;
			case 2:	FileIORespond(AnimReadAVI(pict_cur,GetFileName("Load AVI File","avi"),FALSE));
				restore_screen(); break;
			}; break;
			break;
		case 1:	// save
			switch(choice[2]) {
			case 0:	FileIORespond(AnimWriteVP(GetFileNameSave("Save VP386 Anim","van"),pict_cur,NULL,FALSE,FALSE)); break;
			case 1:	strcpy(packmem,GetFileNameSave("Save VP386 Anim w/Sound","van"));
				FileIORespond(AnimWriteVP(packmem,pict_cur,GetFileName("Audio file","raw"),FALSE,FALSE)); break;
			case 2:	FileIORespond(AnimWritePCX(pict_cur,GetFileNameSave("Save PCX Sequence","pcx")));
				break;
			case 3:	FileIORespond(AnimWriteANI(pict_cur,GetFileNameSave("Save ANI file","ani"))); break;
			case 4:	FileIORespond(AnimWriteVP(GetFileNameSave("Save VP386 Anim","van"),pict_cur,NULL,TRUE,FALSE)); break;
			case 5:	{
					char *s;

					if (s=malloc(768)) {
						strcpy(s,GetFileNameSave("Save VP386 Anim w/Sound","van"));
						FileIORespond(AnimWriteVP(s,pict_cur,GetFileName("Audio file","raw"),TRUE,FALSE));
						free(s);
					}
				}
				break;
			case 6:	FileIORespond(AnimWriteVP(GetFileNameSave("Save VP386 Anim","van"),pict_cur,NULL,FALSE,TRUE)); break;
			case 7:	FileIORespond(AnimWriteFLC(pict_cur,GetFileNameSave("Save FLC file","flc"))); break;
			}; break;
		case 2:	// prev
			VP_PrevFrame(); break;
		case 3: // next
			VP_NextFrame(); break;
		case 4:	// goto
			VP_GotoFrame(); break;
		case 5: // play forward
 			Anim_Playback(pict_cur,NULL);
			break;
		case 6:	// play once
			Anim_Playback(pict_cur,ANIM_PLAYBACK_ONCE);
			break;
		case 7: // pingpong
			Anim_Playback(pict_cur,ANIM_PLAYBACK_PINGPONG);
			break;
		case 8:	// add before
			VP_InsertBeforeFrame(); break;
		case 9: // add after
			VP_InsertAfterFrame(); break;
		case 10:	// delete
			VP_DeleteCurrentFrame(); break;
		case 11: // playback rate
			Anim_SetPlaybackRate(pict_cur); break;
		case 12: // frame palette
			switch(choice[2]) {
			case 0:	// attach from previous
				{
				struct Frame *fr;

				if (pict_cur->total_frames<=1) break;

				fr = pict_cur->current->prev ? pict_cur->current->prev : pict_cur->last;

				if (fr->frame_pal) {
					if (fr->frame_pal != pict_cur->current->frame_pal) {
						DetachFramePalette(pict_cur,pict_cur->current);
						AttachPaletteToFrame(pict_cur,pict_cur->current,fr->frame_pal);
					}
				} else DetachFramePalette(pict_cur,pict_cur->current);
				LoadFramePalette(pict_cur,pict_cur->current);
				SetTitle(NULL);

				} break;
			case 1:	// attach from next
				{
				struct Frame *fr;

				if (pict_cur->total_frames<=1) break;

				fr = pict_cur->current->next ? pict_cur->current->next : pict_cur->first;

				if (fr->frame_pal) {
					if (fr->frame_pal != pict_cur->current->frame_pal) {
						DetachFramePalette(pict_cur,pict_cur->current);
						AttachPaletteToFrame(pict_cur,pict_cur->current,fr->frame_pal);
					}
				} else DetachFramePalette(pict_cur,pict_cur->current);
				LoadFramePalette(pict_cur,pict_cur->current);

				SetTitle(NULL);

				} break;
			case 2:	// attach new framepal
				DetachFramePalette(pict_cur,pict_cur->current);
				if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
					Message("Not enough memory to attach palette");
				LoadFramePalette(pict_cur,pict_cur->current);
				SetTitle(NULL);
				break;
			case 3:	// detach
				DetachFramePalette(pict_cur,pict_cur->current);
				LoadFramePalette(pict_cur,pict_cur->current);
				break;
			case 4:	// detach all
				{
					int i;

					for(i=0;i<pict_cur->total_frames;i++) {
						DetachFramePalette(pict_cur,pict_cur->current);
						PictureNextFrame(pict_cur);
					}
					LoadFramePalette(pict_cur,pict_cur->current);
				}
				break;
			case 5:	// separate
				{
				struct FramePalette *fp = pict_cur->current->frame_pal;

				if (fp) {	// do we even HAVE a frame palette for this frame?
					if (fp->usecount>1) {	// multiplexed palette?
						memcpy(packmem,fp->palette,768);
						DetachFramePalette(pict_cur,pict_cur->current);
						if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
							Message("Not enough memory to attach palette");
						else {
							memcpy(pict_cur->current->frame_pal->palette,packmem,768);
							SetTitle(NULL);
						}
					}
				}
				}break;
			}
			break;
		case 13:
			DoArrange(pict_cur->palette,pict_cur->pal_bits,"Global ");
			break;
		case 14:	// Process
			switch(choice[2]) {
			case 0:	// feather palettes
				{
				struct FramePalette *fp = pict_cur->current->frame_pal;
				int i;

				for(i=0;i<pict_cur->total_frames;i++) {
					PictureNextFrame(pict_cur);
					if (fp = pict_cur->current->frame_pal) {	// do we even HAVE a frame palette for this frame?
						if (fp->usecount>1) {	// multiplexed palette?
							memcpy(packmem,fp->palette,768);
							DetachFramePalette(pict_cur,pict_cur->current);
							if (!AttachPaletteToFrame(pict_cur,pict_cur->current,NULL))
								Message("Not enough memory to attach palette");
							else {
								memcpy(pict_cur->current->frame_pal->palette,packmem,768);
								SetTitle(NULL);
							}
						}
					}
				}
				}break;
			case 1:	// align palettes
				AnimAlignPalettes(pict_cur);
				break;
			}
			break;
		}; break;
	case 3: /* special */
		switch(choice[1]) {
		case 0: /* palette */
			DoPalette();
			break;
		case 1: /* arrange */
			if (pict_cur->current->frame_pal)
				DoArrange(pict_cur->current->frame_pal->palette,pict_cur->pal_bits,"Frame ");
			else
				DoArrange(pict_cur->palette,pict_cur->pal_bits,"Global ");
			break;
		case 2: /* ranges */
			DoRange();
			break;
		case 3: /* dither */
			switch(choice[2]) {
			case 0: /* 640x480 16-color */
				Dither16();
				break;
			case 1:	// 1x1x1 RGB cube
				Dither8(pict_cur);
				restore_screen();
				break;
			case 2: /* 640x480 mono */
				Dither2();
				break;
			}; break;
		case 4: /* process */
			switch(choice[2]) {
			case 0: /* 3x3 average RGB */
				AverageRGB(FALSE);
				break;
			case 1:	// 5x5 average RGB
				AverageRGB(TRUE);
				break;
			case 2: /* 3x3 median RGB */
				MedianRGB();
				break;
			case 3:	/* Invert picture */
				InvertRGB();
				break;
			case 4: // colors most->least
				SortPictureColors(TRUE);
				break;
			case 5:	// colors least->most
				SortPictureColors(FALSE);
				break;
			case 6:	// merge identical colors
				MergeIdenticalColors(NULL);
				break;
			case 7: // PCX Optimize
				PCXOptimizeColors();
				break;
			case 8: // delta-h
				DeltaH();
				break;
			case 9:	// delta-v
				DeltaV();
				break;
			case 10: // undelta-h
				UnDeltaH();
				break;
			case 11: // undelta-v
				UnDeltaV();
				break;
			}; break;
		case 5: /* prepics */
			switch(choice[2]) {
			case 0:	/* color chart */
				colorbars();
				break;
			case 1: /* color bars II */
				colorbars2();
				break;
			case 2: /* rainbows */
				prescr_rainbows();
				break;
			case 3: /* plasma 1 */
				PP_Plasma1();
				break;
			case 4: /* gammatest */
				PP_GammaTest();
				break;
			case 5:	/* gammatest2 */
				PP_GammaTest2();
				break;
			case 6:	// maze
				PP_Maze();
				break;
			case 7:	// std palette
				memcpy(piccol,stdcol,768);
				repick_colors();
				restore_screen();
				break;
			}; break;
		case 6:	/* spare */
			switch(choice[2]) {
			case 0:	// new
				SpareInit(picbm->width,picbm->height);
				break;
			case 1: /* swap */
				SpareSwap();
				break;
			case 2: /* copy */
				SpareCopy();
				break;
			case 3: // sparelist
				SparePictureList();
				break;
			case 4: /* get palette */
				SpareGetPalette();
				break;
			case 5:	// spare fit to palette
				SpareFitToPalette();
				break;
			case 6: /* merge */
				SpareMerge();
				break;
			case 7: /* delete */
				SpareDelete();
				break;
			case 8: /* underlay */
				SpareUnderlay();
				break;
			case 9: /* overlay */
				SpareOverlay();
				break;
			}; break;
		case 7: /* tone */
			switch(choice[2]) {
			case 0:	ToneAdjust();
				break;
			case 1:	ToneAdjust2();
				break;
			case 2:	ColorControl();
				break;
			};
			break;
		case 8: /* conversion */
			switch(choice[2]) {
			case 0:	/* grey scale */
				{
					uchar *c=piccol;
					long x,y;

					for(x=0;x<256;x++) {
						y=(30*c[0]+59*c[1]+11*c[2]+50)/100;
						*c++=*c++=*c++=y;
					};

					repick_colors();
					restore_screen();
				}
				break;
			case 1:	/* black & white */
				{
					uchar *c=piccol,y;
					long x;

					for(x=0;x<256;x++) {
						y=(30*c[0]+59*c[1]+11*c[2]+50)>=3175 ? 63 : 0;
						*c++=*c++=*c++=y;
					};

					repick_colors();
					restore_screen();
				}
				break;
			case 2:	// grey palette
				{
					uchar *c=piccol;
					uchar *p=packmem;
					long x;

					for(x=0;x<256;x++) {
						*p++=(30*c[0]+59*c[1]+11*c[2]+50)/100;
						c+=3;
					};

					vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

					c=piccol;
					for(x=0;x<256;x++) { c[0]=c[1]=c[2]=x; c+=3; }

					repick_colors();
					restore_screen();
				}
				break;
			case 3:	// grey palette (64)
				{
					uchar *c=piccol;
					uchar *p=packmem;
					long x;

					for(x=0;x<256;x++) {
						*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*4);
						c+=3;
					};

					vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

					c=piccol;
					for(x=0;x<64;x++) { c[0]=c[1]=c[2]=expand6to8(x); c+=3; }

					repick_colors();
					restore_screen();
				}
				break;
			case 4:	// grey palette (16)
				{
					uchar *c=piccol;
					uchar *p=packmem;
					long x;

					for(x=0;x<256;x++) {
						*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*16);
						c+=3;
					};

					vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

					c=piccol;
					for(x=0;x<16;x++) { c[0]=c[1]=c[2]=x*17; c+=3; }

					repick_colors();
					restore_screen();
				}
				break;
			case 5:	// grey palette (8)
				{
					uchar *c=piccol;
					uchar *p=packmem;
					long x,y;

					for(x=0;x<256;x++) {
						*p++=(30*c[0]+59*c[1]+11*c[2]+50)/(100*32);
						c+=3;
					};

					vid13_translate(picbm,0,0,picbm->width,picbm->height,packmem);

					c=piccol;
					for(x=0;x<16;x++) { c[0]=c[1]=c[2]=(x*255L)/7; c+=3; }

					repick_colors();
					restore_screen();
				}
				break;
			};
			break;
		case 9:	/* fillmode */
			if (choice[2]==8) {
				if (choice[3]!=-1) fill_ccrange=choice[3];
			} else if (choice[2]!=-1) {
				menu_choose(fillmenu,0,7,fillmode=choice[2]);
				if (fillmode>=2) {	/* spec. fill mode */
					vsd=&vs_drivers[fillmode-2];
					fillmode=2;
				};
			};
			break;
		case 10: /* drawmode */
			switch(choice[2]) {
			case -1:	break;
			case 3:	if (choice[3]!=-1) {	/* drawing range */
					menu_choose(rangemenu,0,-1,choice[3]);
					dcrange=choice[3];
					dcstrip=0;
				};
				break;
			default:	/* a drawing mode */
				if (choice[2]!=-1)
					menu_choose(drawmenu,0,-1,dcmode=choice[2]);
				break;
			}; break;
		case 11: /* linemode */
			if (choice[2]!=-1) menu_choose(linemenu,0,-1,linemode=choice[2]);
			break;
		case 12: // blitmode
			if (choice[2]!=-1) menu_choose(blitmenu,0,-1,blitmode=choice[2]);
			break;
		case 13: // tilemode
			switch(choice[2]) {
			case 0:	opt.tile_zoom = menu_toggle();
				break;
			}
			break;
		}; break;
	case 4: /* prefs */
		switch(choice[1]) {
		case 0:		/* video driver */
			SelectVideoDriver();
			break;
		case 1:		// Capture mode
			CaptModeRequest();
			break;
		case 2:		/* repeat draw */
			opt.reptdraw=menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","RepeatDraw","%d",opt.reptdraw);
			break;
		case 3:		// coords
			opt.coords=menu_toggle();
			SetTitle(NULL);
			IniAddItem(main_vp386_ini,"Prefs","Coords","%d",opt.coords);
			break;
		case 4:		/* be square (aspect ratio) */
			opt.be_square=menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","BeSquare","%d",opt.be_square);
			break;
		case 5:		/* autotransp */
			opt.autotransp=menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","AutoTransparency","%d",opt.autotransp);
			break;
		case 6:		// brush bound adjust
			opt.adjustBrush = menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","AdjustBrushBounds","%d",opt.adjustBrush);
			break;
		case 7:		/* flickerfree brush */
			opt.brushflickerfree=menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","FlickerFreeBrush","%d",opt.brushflickerfree);
			break;
		case 8:		// hires tools
			opt.useHiresTools = menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","HiresTools","%d",opt.useHiresTools);
			break;
		case 9:	// CPUhog
			opt.CPUhog=menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","ImitateWindows95","%d",opt.CPUhog);
			break;
		case 10:	// half screen
			{
				uchar x,z;
				ushort y;

				disable();
				outportb(0x3d4,0x09);
				x=inportb(0x3d5);
				x=(x&0xFE)+(menu_toggle()^1);
				outportb(0x3d5,x);

				y=vidbm.height;
				if (x & 1) y<<=1;
				y--;

				/* deprotect CRTC registers */

				outportb(0x3d4,0x11);
				x=inportb(0x3d5);
				outportb(0x3d4,0x11);
				outportb(0x3d5,x & 127);

				/* write new VDE value */

				outportb(0x3d4,0x12);
				outportb(0x3d5,y & 255);
				outportb(0x3d4,0x07);
				z=inportb(0x3d5);
				outportb(0x3d4,0x07);
				z&=0xBD;
				if (y & 256) z+=0x02;
				if (y & 512) z+=0x40;
				outportb(0x3d5,z);

				/* protect CRTC registers */

				outportb(0x3d4,0x11);
				x=inportb(0x3d5);
				outportb(0x3d4,0x11);
				outportb(0x3d5,x | 128);

				enable();
				break;
			}
		case 11:	/* lines in screen */
			if (choice[2]>=0) {
				disable();
				outportb(0x3c2,(inportb(0x3cc) & 0x3F)+64+(choice[2]<<6));
				enable();
				sizemenu[0].name[0]=' ';
				sizemenu[1].name[0]=' ';
				sizemenu[2].name[0]=' ';
				sizemenu[choice[2]].name[0]='*';

				switch(choice[2]) {
				case 0:	x_ratio = 0x11c71L;	y_ratio = 0x0e666L;	// 400 lines (1.11:1 approx)
					break;
				case 1:	x_ratio = 0x14835L;	y_ratio = 0x0c7aeL;	// 350 lines (1.28:1 approx)
					break;
				case 2:	x_ratio = 0x10000L;	y_ratio = 0x10000L;	// 480 lines (1.00:1)
					break;
				}
			}
			break;
		case 12:	/* monitor gamma adjust */
			switch(choice[2]) {
			case 0:
				opt.gamma_adjust = menu_toggle();

				IniAddItem(main_vp386_ini,vdrv_cur->name,"UseGammaAdjustment","%d",opt.gamma_adjust);

				// reload all colors

				{
					char *m;

					if (m=malloc(768)) {
						vid_saveRGB6(0,m,256);
						vid_loadRGB6(0,m,256);
						free(m);
					}
				}

				break;
			case 1:
				MonitorGammaAdjust();
				IniAddItem(main_vp386_ini,vdrv_cur->name,"RedGamma","%7.5f",1.0/monitor_rgamma);
				IniAddItem(main_vp386_ini,vdrv_cur->name,"GreenGamma","%7.5f",1.0/monitor_ggamma);
				IniAddItem(main_vp386_ini,vdrv_cur->name,"BlueGamma","%7.5f",1.0/monitor_bgamma);
				break;
			}
			break;
		case 13:	// scroll mode
			switch(choice[2]) {
			case 0: case 1:
				menu_choose(scrollmenu,0,2,scroll_mode=choice[2]);
				IniAddItem(main_vp386_ini,"Prefs","ScrollMode","%d",scroll_mode);
				break;
			case 2:
				scroll_speed_req();
				IniAddItem(main_vp386_ini,"Prefs","ScrollSpeed","0x%lx",scroll_speed);
				break;
			}
			break;
		case 14:	// fast preview
			opt.fastPreview = menu_toggle();
			IniAddItem(main_vp386_ini,"Prefs","FastPreview","%d",opt.fastPreview);
			break;
		case 15:	// save settings
			switch(choice[2]) {
			case 1:
				IniAddItem(main_vp386_ini,"Prefs","StartVideoMode","\"%s\"",vdrv_cur->name);
				break;
			case 2:
				IniAddItem(main_vp386_ini,"Prefs","PictureWidth","%ld",picbm->width);
				IniAddItem(main_vp386_ini,"Prefs","PictureHeight","%ld",picbm->height);
				break;
			}
			if (choice[2]>=0) {
				FILE *f;

				if (f=VPfopen("VP:vp386.ini","w"))
					if (IniWriteFile(f,main_vp386_ini))
						if (!fclose(f))
							break;
					
				Message("Error writing VP386.INI.");
			}
			break;
		case 16:	// reduce mode
			switch(choice[2]) {
			case -1:
				break;
			case 0:
				reduce_maxcol = RequestSlider("Max Colors To Reduce To",0,256,reduce_maxcol);
				break;
			case 1:
				if (choice[3]>=0)
					menu_choose(reducedithermodemenu,0,4,reducedither_mode = choice[3]);
				break;
			case 2:
				if (choice[3]>=0)
					menu_choose(reduceplacemodemenu,0,2,reduceplace_mode = choice[3]);
				break;
			default:
				menu_choose(reducemodemenu,3,3,choice[2]);
				reduce_mode = choice[2]-3;
				IniAddItem(main_vp386_ini,"Prefs","ReduceMode","%d",reduce_mode);
			}
			break;
		}; break;
	case 5: /* extension */
		switch(choice[1]) {
		case 0:		// extension list
			ExtensionDisplayInfoList();
			break;
		case 1:		/* run extension */
			run_extension(GetFileName("Run Extension","vex"));
			break;
		};
		break;
	case 6:	// help
		DisplayHelpTopic(vp386_helpfile,"main-help");
		break;
	};
}

void MenuPickHelp(void) {
	struct Menu *menu=barmenu+1;
	int i=0;
	char c,*s,*t=packmem+5;

	strcpy(packmem,"menu/");

	while(choice[i]>-1) {
		menu = menu_item_address(menu,choice[i],-1);

		// copy the name, but strip off any starting asterisk and leading/trailing spaces
		// delete ellipses (...)

		s = menu->name;
		if (*s=='*') ++s;
		while(*s==' ') ++s;
		while(c=*s++) {
			if (c=='.')
				if (s[0]=='.')
					if (s[1]=='.') {
						s+=2;
						continue;
					}
			*t++=c;
		}
		while(t>packmem) if (t[-1]==' ') --t; else break;
		*t++='/';

		menu=menu->first;
		++i;
	}
	t[-1]=0;
	DisplayHelpTopic(vp386_helpfile,packmem);
}


