#ifndef	VGAPAINT_PCX_H
#define	VGAPAINT_PCX_H

#include <stdio.h>

#ifndef	VGAPAINT_PCXCOM_H
extern uchar pcxcom_uncomp[];
extern uchar pcxcom_compr[];
#endif

#define	IFF_Line_Max(s)	((s)+((s)+127)/128)

struct	BMPFileHeader {
	ushort	bfType;				// "BM" or 0x4D42
	ulong	bfSize;				// size of file in bytes
	ulong	bfReserved;			// zero
	ulong	bfOffBits;			// offset in file where bits begin
};

struct	BMPInfoHeader {
	ulong	biSize;				// size of this structure
	ulong	biWidth;			// width in pixels
	ulong	biHeight;			// height in pixels
	ushort	biPlanes;			// # of color planes: must be 1
	ushort	biBitCount;			// color bits per pixel: set this to 8
	ulong	biCompression;			// compression (BI_RGB: 0) 
	ulong	biSizeImage;			// number of bitmap bytes (can set this to zero)
	ulong	biXPelsPerMeter;		// horiz resolution (80)
	ulong	biYPelsPerMeter;		// vert resolution (72)
	ulong	biClrUsed;			// # of colors used
	ulong	biClrImportant;			// important colors
};

enum	PictureIOErrors {
	PIOERR_NONE,
	PIOERR_OPEN,
	PIOERR_READ,
	PIOERR_WRITE,
	PIOERR_BADFORMAT,
	PIOERR_MEMORY,		// not enough memory
	PIOERR_NONAME,		// aborted because no name to write
	PIOERR_BADSIZE,		// file written must be a particular size
	PIOERR_ABORT_USER,	// aborted because of user
	PIOERR_UNKNOWN,		// unknown error
};

enum PictureIOErrors	PCXWrite(char *,struct BitMap *bm,uchar *pal);
enum PictureIOErrors	PCXWrite4(char *,struct BitMap *bm);
enum PictureIOErrors	PCXWrite24(char *,struct BitMap *bm,uchar *,uchar *,uchar *);
enum PictureIOErrors	PCXWriteSFX(char *name,struct BitMap *bm);
long			pack_PCX_row(uchar *dst,uchar *src,long len);
long			pack_PCX_row24(uchar *dst,uchar *src,long len);
enum PictureIOErrors	PCXCom_Write(char *,struct BitMap *bm);
int			PCXRead(char *,boolean interactive);
boolean			unpack_PCX_row(uchar *,FILE *,long);
void			Raw256_Extract(char *);
enum PictureIOErrors	Pak_Dump(char *,struct BitMap *);
enum PictureIOErrors	HP48Write3(char *,struct BitMap *);

void	PCX_Demultiplex(uchar *dmem,uchar *smem,ulong width,uchar bpp,uchar planes,ulong byteskip);

boolean	IFF_Line_Decompress(uchar *output,FILE *i,long length);
boolean	IFF_Line_DecompressMemory(uchar *output,uchar *input,long length);
ulong	IFF_Line_Compress(uchar *output,uchar *input,long length);
ulong	IFF_Line_Compress_Cautious(uchar *output,uchar *input,long length,long maxlen);
ulong	IFF_Line_Compress_Predict(uchar *input,long length);

boolean	IFFRequest(void);
enum PictureIOErrors	IFFWrite(char *output,struct BitMap *bm);
boolean	IFFRead(char *name);

int	BMPWrite(char *fname,struct BitMap *bm);
int	BMPRead(char *fname);

int	PALRead(char *fname);
int	PALWrite(char *fname,struct BitMap *bm);

void	ReducePalette(short,uchar *,uchar *);
void	ChunkyToPlanar(uchar *,uchar *,ulong,short);
void	PlanarToChunky(uchar *,uchar *,ulong,short);

#endif

