#ifndef	A_BITS_H
#define A_BITS_H

#include <a/types.h>

ulong	scale32u(ulong value,ulong multiplier,ulong divisor);
long	scale32i(long value,long multiplier,long divisor);
uchar	brotl(uchar value,uchar bits);
uchar	brotr(uchar value,uchar bits);
ushort	swapbytes16(ushort);
ulong	swapbytes32(ulong);
uchar	expand5to6(uchar value5bit);
uchar	expand2to8(uchar value2bit);
uchar	expand3to8(uchar value3bit);
uchar	expand4to8(uchar value4bit);
uchar	expand5to8(uchar value5bit);
uchar	expand6to8(uchar value6bit);
ushort	expand8to16(uchar value8bit);
ulong	expand8to16L(uchar value8bit);
ulong	expand8to32(uchar value8bit);
ulong	psr32adv16(ulong seed);		// seed cannot be zero

long	fixedmul_32x16fi(long x,long y);

#pragma aux scale32u="mul ebx","div ecx" parm [eax] [ebx] [ecx] value [eax] modify exact nomemory [eax edx];
#pragma aux scale32i="imul ebx","idiv ecx" parm [eax] [ebx] [ecx] value [eax] modify exact nomemory [eax edx];
#pragma aux brotl="rol al,cl" parm [al] [cl] value [al] modify exact nomemory [al];
#pragma aux brotr="ror al,cl" parm [al] [cl] value [al] modify exact nomemory [al];
#pragma aux swapbytes32="xchg al,ah","rol eax,16","xchg al,ah" parm [eax] value [eax] modify exact nomemory [eax];
#pragma aux swapbytes16="xchg al,ah" parm [ax] value [ax] modify exact nomemory [ax];
#pragma aux expand5to6="mov ah,al","shl al,1","shr ah,4","or al,ah" parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand2to8="and al,3","mov ah,al","shl al,2","or al,ah","mov ah,al","shl ah,4","or al,ah" \
		parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand3to8="and al,7","mov ah,al","shl ah,3","or al,ah","shr al,1","shl ah,2","or al,ah" \
		parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand4to8="and al,15","mov ah,al","shl al,4","or al,ah" parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand5to8="mov ah,al","shl al,3","shr ah,5","or al,ah" parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand6to8="mov ah,al","shl al,2","shr ah,6","or al,ah" parm [al] value [al] modify exact nomemory [eax];
#pragma aux expand8to16="mov ah,al" parm [al] value [ax] modify exact nomemory [ax];
#pragma aux expand8to16L="mov ah,al" parm [al] value [eax] modify exact nomemory [eax];
#pragma aux expand8to32="mov ah,al","rol eax,8","mov al,ah","rol eax,8","mov al,ah" parm [al] value [eax] \
	modify exact nomemory [eax];

#pragma aux fixedmul_32x16fi="imul ebx","shrd eax,edx,16" parm [eax] [ebx] value [eax] modify exact nomemory [eax edx];

#pragma aux psr32adv16=	\
	"ror eax,16",	\
	"mov ebx,eax",	\
	"xor bl,bl",	\
	"xor bh,bh",	\
	"ror ebx,3",	\
	"xor eax,ebx",	\
	"ror ebx,1",	\
	"xor eax,ebx",	\
	"ror ebx,1",	\
	"xor eax,ebx",	\
	parm [eax] value [eax] modify exact nomemory [eax ebx];

#endif


