#if !defined(A_MEM_H) && !defined(BRIGHTEYES_MEM_H)
#define	A_MEM_H

void *qmovel(void *dest,void *src,ulong size);
#pragma aux qmovel =	 	\
	"rep movsd"		\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi ecx];

void *qmoveb(void *dest,void *src,ulong size);
#pragma aux qmoveb =		\
	"rep movsb"		\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi ecx];

void *qmove(void *dest,void *src,ulong size);
#pragma aux qmove =		\
	"mov ecx,eax",		\
	"shr ecx,2",		\
	"and eax,3",		\
	"rep movsd",		\
	"mov ecx,eax",		\
	"rep movsb"		\
	parm [edi] [esi] [eax]	\
	value [esi]		\
	modify exact [esi edi ecx];

void *qmove2(void *dest,void *src,ulong size4,uchar size1);
#pragma aux qmove2 =		\
	"rep movsd",		\
	"mov ecx,eax",		\
	"rep movsb"		\
	parm [edi] [esi] [ecx] [eax]	\
	value [esi]		\
	modify exact [esi edi ecx];

void *qmove2r(void *dest,void *src,ulong size4,uchar size1);
#pragma aux qmove2r =		\
	"std",			\
	"sub esi,4",		\
	"sub edi,4",		\
	"rep movsd",		\
	"add esi,3",		\
	"add edi,3",		\
	"mov ecx,eax",		\
	"rep movsb",		\
	"cld"			\
	parm [edi] [esi] [ecx] [eax]	\
	value [esi]		\
	modify exact [esi edi ecx];

ulong *qmovelr(ulong *dest,ulong *src,ulong size);
#pragma aux qmovelr =	 	\
	"std",			\
	"rep movsd"		\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi ecx];

uchar *qmovebr(uchar *dest,uchar *src,ulong size);
#pragma aux qmovebr =		\
	"std",			\
	"rep movsb"		\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi ecx];

uchar *qmovebes(uchar *dest,uchar *src,ulong size);
#pragma aux qmovebes =		\
	"cld",			\
	"push es",		\
	"push ds",		\
	"pop es",		\
	"rep movsb",		\
	"pop es"		\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi ecx];

ulong *qsetl(ulong *dest,ulong lword,ulong size);
#pragma aux qsetl =		\
	"rep stosd"		\
	parm [edi] [eax] [ecx]	\
	value [edi]		\
	modify exact [edi ecx];

uchar *qsetb(uchar *dest,uchar byte,ulong size);
#pragma aux qsetb =		\
	"rep stosb"		\
	parm [edi] [al] [ecx]	\
	value [edi]		\
	modify exact [edi ecx];

void *qsetw(void *dest,short word,ulong size);
#pragma aux qsetw = "rep stosw" parm [edi] [ax] [ecx] value [edi] modify exact [edi ecx];

void *qset(void *dest,uchar byte,ulong size);
#pragma aux qset =		\
	"mov ah,al",		\
	"mov bx,ax",		\
	"shl eax,16",		\
	"mov ax,bx",		\
	"mov ebx,ecx",		\
	"shr ecx,2",		\
	"rep stosd",		\
	"and ebx,3",		\
	"mov ecx,ebx",		\
	"rep stosb"		\
	parm [edi] [al] [ecx]	\
	value [edi]		\
	modify exact [eax ebx ecx edi];

void *qset2(void *dest,ulong xl,ulong size4,ulong size1);
#pragma aux qset2 =		\
	"rep stosd",		\
	"mov ecx,ebx",		\
	"rep stosb"		\
	parm [edi] [eax] [ecx] [ebx]	\
	value [edi]		\
	modify [edi ecx];

void outportb(ushort port,char b);
#pragma aux outportb =		\
	"out dx,al"		\
	parm [dx] [al]		\
	modify exact [] nomemory;

char inportb(short port);
#pragma aux inportb =		\
	"in al,dx"		\
	parm [dx]		\
	modify exact [al]	\
	value [al];		\

void outportw(ushort port,short b);
#pragma aux outportw =		\
	"out dx,ax"		\
	modify exact []		\
	parm [dx] [ax];

short inportw(ushort port);
#pragma aux inportw =		\
	"in ax,dx"		\
	parm [dx]		\
	modify exact [ax] 	\
	value [ax];

void outportbs(ushort port,uchar *s,ulong n);
#pragma aux outportbs =		\
	"rep outsb"		\
	parm [dx] [esi]	[ecx]	\
	modify exact [esi ecx];
	
void inportbs(ushort port,uchar *s,ulong n);
#pragma aux inportbs =		\
	"rep insb"		\
	parm [dx] [edi]	[ecx]	\
	modify exact [edi ecx];

void disable(void);
#pragma aux disable = "cli" modify exact [] nomemory;

void enable(void);
#pragma aux enable = "sti" modify exact [] nomemory;

void disable2(void);
#pragma aux disable2="pushfd","cli" modify exact [] nomemory;

void enable2(void);
#pragma aux enable2="popfd" modify exact [] nomemory;

ulong *qxorl(ulong *dest,ulong xrv,ulong size);
#pragma aux qxorl =	 	\
	"l:",			\
	"xor [edi],eax",	\
	"add edi,4",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [eax] [ecx]	\
	value [edi]		\
	modify exact [edi ecx];

uchar *qxorb(uchar *dest,uchar xrv,ulong size);
#pragma aux qxorb =		\
	"l:",			\
	"xor [edi],al",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [al] [ecx]	\
	value [edi]		\
	modify exact [edi ecx];

void *qxor(void *dest,uchar xrv,ulong size);
#pragma aux qxor =		\
	"mov ah,al",		\
	"mov bx,ax",		\
	"shl eax,16",		\
	"mov ax,bx",		\
	"mov ebx,ecx",		\
	"shr ecx,2",		\
	"je  l4",		\
	"l1:",			\
	"xor [edi],eax",	\
	"add edi,4",		\
	"dec ecx",		\
	"jne l1",		\
	"l4:",			\
	"and ebx,3",		\
	"je  l3",		\
	"l2:",			\
	"xor [edi],al",		\
	"inc edi",		\
	"dec ebx",		\
	"jne l2",		\
	"l3:",			\
	parm [edi] [al] [ecx]	\
	value [edi]		\
	modify exact [edi ecx eax ebx];

void *qxor2(void *dest,ulong xrv,ulong size4,ulong size1);
#pragma aux qxor2 =		\
	"test ecx,ecx",		\
	"je   l1",		\
	"l2:",			\
	"xor  [edi],eax",	\
	"add  edi,4",		\
	"dec  ecx",		\
	"jne  l2",		\
	"l1:",			\
	"test ebx,ebx",		\
	"je   l3",		\
	"l4:",			\
	"xor  [edi],al",	\
	"inc  edi",		\
	"dec  ebx",		\
	"jne  l4",		\
	"l3:"			\
	parm [edi] [eax] [ecx] [ebx]	\
	value [edi]		\
	modify exact [edi ebx ecx];

ulong *qswapl(ulong *dest,ulong *src,ulong size);
#if 0
#pragma aux qswapl =	 	\
	"l:",			\
	"mov eax,[edi]",	\
	"xchg [esi],eax",	\
	"mov [edi],eax",	\
	"add esi,4",		\
	"add edi,4",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi eax ecx];
#else
#pragma aux qswapl =		\
	"sub esi,4",		\
	"sub edi,4",		\
	"l:",			\
	"mov eax,[esi+ecx*4]",	\
	"mov ebx,[edi+ecx*4]",	\
	"mov [edi+ecx*4],eax",	\
	"mov [esi+ecx*4],ebx",	\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi eax ebx ecx];
#endif

uchar *qswapb(uchar *dest,uchar *src,ulong size);
#pragma aux qswapb =		\
	"l:",			\
	"mov al,[edi]",		\
	"xchg [esi],al",	\
	"mov [edi],al",		\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx]	\
	value [esi]		\
	modify exact [edi esi al ecx];

ulong *qswap2(ulong *dest,ulong *src,ulong size);
#pragma aux qswap2 =	 	\
	"mov ecx,edx",		\
	"shr ecx,2",		\
	"jz  l2",		\
	"l:",			\
	"mov eax,[edi]",	\
	"xchg [esi],eax",	\
	"mov [edi],eax",	\
	"add esi,4",		\
	"add edi,4",		\
	"dec ecx",		\
	"jne l",		\
	"l2:",			\
	"mov ecx,edx",		\
	"and ecx,3",		\
	"jz  l4",		\
	"l3:",			\
	"mov al,[edi]",		\
	"xchg [esi],al",	\
	"mov [edi],al",		\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l3",		\
	"l4:"			\
	parm [edi] [esi] [edx]	\
	value [esi]		\
	modify exact [edi esi eax ecx];

uchar *qswaptrnb(uchar *dest,uchar *src,ulong size,uchar trncol);
#pragma aux qswaptrnb =		\
	"l:",			\
	"mov al,[edi]",		\
	"cmp al,bl",		\
	"jz s",			\
	"xchg [esi],al",	\
	"mov [edi],al",		\
	"s:",			\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx] [bl]	\
	value [esi]		\
	modify exact [edi esi al ecx];

uchar *qswapmskb(uchar *dest,uchar *src,ulong size,uchar *msk,uchar c);
#pragma aux qswapmskb =		\
	"l:",			\
	"mov al,[esi]",		\
	"cmp al,ah",		\
	"jz s",			\
	"mov al,[edi]",		\
	"xchg [ebx],al",	\
	"mov [edi],al",		\
	"s:",			\
	"inc esi",		\
	"inc edi",		\
	"inc ebx",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [ebx] [ecx] [esi] [ah]	\
	value [esi]		\
	modify exact [edi esi al ecx ebx];

uchar *qmoveclrb(uchar *dest,uchar *src,ulong size,uchar trncol,uchar cl);
#pragma aux qmoveclrb =		\
	"cld",			\
	"l:",			\
	"mov al,[esi]",		\
	"cmp al,bl",		\
	"jz s",			\
	"mov [edi],bh",		\
	"s:",			\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx] [bl] [bh]	\
	value [esi]		\
	modify exact [edi esi ecx al];

uchar *qmovetrnb(uchar *dest,uchar *src,ulong size,uchar trncol);
#pragma aux qmovetrnb =		\
	"l:",			\
	"mov al,[esi]",		\
	"cmp al,bl",		\
	"jz s",			\
	"mov [edi],al",		\
	"s:",			\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx] [bl]	\
	value [esi]		\
	modify exact [edi esi ecx al];

void Click(void);
#pragma aux Click =		\
	"mov dx,0061h",		\
	"in al,dx",		\
	"and al,0feh",		\
	"xor al,002h",		\
	"out dx,al"		\
	modify [edx al];

uchar *qtrncpy(uchar *dest,uchar *src,ulong size,uchar *trnb);
#pragma aux qtrncpy =		\
	"xor eax,eax",		\
	"l:",			\
	"mov al,[esi]",		\
	"mov al,[ebx+eax]",	\
	"mov [edi],al",		\
	"inc esi",		\
	"inc edi",		\
	"dec ecx",		\
	"jne l"			\
	parm [edi] [esi] [ecx] [ebx]	\
	value [esi]		\
	modify exact [edi esi ecx eax];

void chgcolor(uchar *mem,uchar nc,ulong size);
#pragma aux chgcolor =		\
	"l:",			\
	"mov al,[esi]",		\
	"test al,al",		\
	"jz s",			\
	"mov [esi],ah",		\
	"s:",			\
	"inc esi",		\
	"dec ecx",		\
	"jne l"			\ 
	modify exact [al]		\
	parm [esi] [ah] [ecx];

void	fix_es(void);
#pragma	aux fix_es = "push ds","pop es" modify exact [];

#endif


