#include <conio.h>
#include <i86.h>

#include <a/types.h>
#include <a/mem.h>
#include "loadlib.h"
#include "toolicon.h"
#include "video.h"
#include "extdata.h"
#include "vpalias.h"

boolean	ovid_init(enum VD_InitCode vdic,long x,long y);
void	ovid_rbitblt(coord x1,coord y1,coord xs,coord ys,uchar *mem,long dmod,boolean no_offset);
void	ovid_rhline(coord x,coord y,uchar *mem,coord xs);
void	ovid_rhlineread(coord x,coord y,uchar *mem,coord xs);
void	ovid_drawptr(struct MousePointerInfo *mpi,coord x,coord y);
void	ovid_eraseptr(struct MousePointerInfo *mpi);
void	ovid_hideptr(struct MousePointerInfo *mpi,boolean new_state);
void	ovid_changeptr(struct MousePointerInfo *mpi);

struct VDevSpecs ovds={
	1024,768,1024,768,1024,768,1024,768
};

struct VDev ovd={
	NULL,				// set
	NULL,				// plot
	NULL,				// point
	NULL,				// bar
	NULL,				// bitblt
	NULL,				// bitbltcolor
	NULL,				// bitblttrans
	NULL,				// bitbltswap
	NULL,				// bitbltswaptrans
	NULL,				// bitbltswapmask,
	NULL,				// bltpattern
	NULL,				// bltpattern3d
	NULL,				// text6
	NULL,				// text6trans
	NULL,				// text6lim,
	NULL,				// hline
	NULL,				// vline
	NULL,				// line
	NULL,				// box
	NULL,				// circle
	NULL,				// ellipse
	NULL,				// blocksave
	NULL,				// blockrestore
	NULL,				// hblit
	NULL,				// vblit
	NULL,				// tile
	NULL,				// rassize
	NULL,				// bpr
	&ovid_init,
	NULL,				// refresh
	&ovid_rhline,
	NULL,				// quickfill
	&ovid_rbitblt,
	&ovid_drawptr,
	&ovid_eraseptr,
	&ovid_rhlineread,
	&ovid_hideptr,
	&ovid_changeptr
};

struct VideoDriver ourVideoDriver={
	{NULL},"S3 Trio64 1024x768 linear",&ovd,NULL,VDF_VESA+VDF_FONT12x16+VDF_NOBUFFER,256,VDEV_SIZE,VDRV_SIZE,3,3
};

void *buffer_memory;
ulong *pointer_memory;

void *DPMIPhysMapAttempt(ulong addr,ulong len) {
	union REGS regs;
	regs.x.eax = 0x0800;
	regs.x.ebx = addr>>16;
	regs.x.ecx = addr;
	regs.x.esi = len>>16;
	regs.x.edi = len;
	int386(0x31,&regs,&regs);

	if (regs.x.cflag & INTR_CF) return NULL;
	else return (void *)(((ulong)regs.x.ebx<<16) | ((ulong)regs.x.ecx & 0xFFFF));
}

long main(struct Extension *ext,enum ExtCommand comm,long xval,long yval) {
	switch(comm) {
	case	EC_STARTUP:
		return (long)&main;

	case	EC_STARTUP1:
		ext->name = "S3 Vision864/Trio 64 LFB driver";

		// allocate memory

		if (!(buffer_memory = DPMIPhysMapAttempt(0xa0000000,0x400000))) return TRUE;
		pointer_memory = (ulong *)buffer_memory + 0x7FF00;

		// add our video driver to the list

		return !AddVideoDriver(&ourVideoDriver);

	case	EC_CLEANUP:

		// remove our video driver from the list

		RemVideoDriver(&ourVideoDriver);

		return 0;

	default:
		return -1;	// whatever it was, we didn't do it
	};
}

void	unlock_s3(void) {
	outp(0x3d4,0x38); outp(0x3d5,0x48);
	outp(0x3d4,0x39); outp(0x3d5,0xa5);
	outp(0x3d4,0x40); outp(0x3d5,inp(0x3d5) | 1);
}


boolean	ovid_init(enum VD_InitCode vdic,long x,long y) {
	union REGS regs;

	switch(vdic) {
	case VD_STARTUP:
		*_vds=&ovds;
		vid_initBitMap(_vidbm,buffer_memory,0,0,1024,768,1024,(*_picbm)->pal);
	case VD_REINIT:
	case VD_TO13:
		regs.x.eax = 0x4f02;
		regs.x.ebx = 0x105;
		int386(0x10,&regs,&regs);
		unlock_s3();
		outp(0x3d4,0x58); outp(0x3d5,inp(0x3d5) | 1);
		outp(0x3d4,0x31); outp(0x3d5,inp(0x3d5) | 8);

		outp(0x3d4,0x54); outp(0x3d5,(inp(0x3d5)&0xf3)+0x00);	// 8-bit packedpixel

		outp(0x3d4,0x5a); outp(0x3d5,0x00);	// memory address $a0000000
		outp(0x3d4,0x59); outp(0x3d5,0xa0);

		outp(0x3d4,0x58); outp(0x3d5,inp(0x3d5) | 16);
		vid_initBitMap(_realvidbm,buffer_memory,0,0,1024,768,1024,(*_picbm)->pal);

		vid_tap_reset(_vidbm);
		_vidbm->syncrect=FALSE;
		break;
	case VD_FROM13:
	case VD_CLOSEDOWN:
		vid_setmode(0x13);
		break;
	case VD_GOBUFFER:
	case VD_GODIRECT:
		break;
	case VD_RESIZE:
		if (x!=1024 || y!=768) return FALSE;
		break;
	};
	return TRUE;
}

void	ovid_rbitblt(coord x1,coord y1,coord xs,coord ys,uchar *mem,long dmod,boolean no_offset) {
	ulong offs=x1+y1*_realvidbm->bpr;

	if (!no_offset) mem+=offs;

	rectcopy(_realvidbm->vm+offs,_realvidbm->bpr,mem,dmod,xs,ys);
};

void	ovid_rhline(coord x,coord y,uchar *mem,coord xs) {
	qmove(_realvidbm->vm+x+_realvidbm->bpr*y,mem,xs);
}

void	ovid_rhlineread(coord x,coord y,uchar *mem,coord xs) {
	qmove(mem,_realvidbm->vm+x+_realvidbm->bpr*y,xs);
}

/* WARNING: Pointer functions are called from INTERRUPT! */

#pragma off (check_stack)

#if 0
void	ovid_drawptr(struct MousePointerInfo *mpi,coord x,coord y) {
	uchar *vm=(uchar *)_realvidbm->vm;
	uchar *dm1=mpi->image;
	uchar *dm2=mpi->backup;
	uchar c;
	ushort xh=16,yh=16,xht;
	ushort vmod,dmod;

	if (x>=0)	vm+=x;
	if (y>=0)	vm+=(y * _realvidbm->bpr);

	mpi->vdp=vm;

	if (y<0) {
		yh+=y;
		dm1-=y*16;
	} else if (y>_realvidbm->height-16) yh=_realvidbm->height-y;

	if (x<0) {
		xh+=x;
		dm1-=x;
	} else if (x>_realvidbm->width-16) xh=_realvidbm->width-x;

	vmod=_realvidbm->bpr-xh;
	dmod=16-xh;

	mpi->width=xh;
	mpi->height=yh;

	while(yh--) {
		for(xht=xh;xht;xht--) {
			*dm2++=*vm;
			if (c=*dm1++) *vm++=(c-1)?mpi->high:mpi->low; else vm++;
		};
		vm  += vmod;
		dm1 += dmod;
	};
}

void	ovid_eraseptr(struct MousePointerInfo *mpi) {
	uchar *vm=mpi->vdp;
	uchar *dm=mpi->backup;
	ushort x=mpi->width;
	ushort y=mpi->height;

	while(y--) {
		dm=qmovebes(vm,dm,x);
		vm+=_realvidbm->bpr;
	};

}

#endif

void	ovid_drawptr(struct MousePointerInfo *mpi,coord x,coord y) {
	int i;
	ulong *p = (ulong *)buffer_memory + 0x40000;

//	x -= mpi->hot_x;	// compensate for 2x zoom
//	y -= mpi->hot_y;	// compensate for 2x zoom

	outp(0x3d4,0x45); outp(0x3d5,(inp(0x3d5) | 0x01) & 0xf3);	// cursor on, no zoom

	outp(0x3d4,0x4d); outp(0x3d5,0xFF);	// buffer address = $07FF*1024 = $1FFC00
	outp(0x3d4,0x4c); outp(0x3d5,0x07);

	outp(0x3d4,0x4e); outp(0x3d5,x<0 ? -x : 0x00);	// start offset X
	outp(0x3d4,0x4f); outp(0x3d5,y<0 ? -y : 0x00);	// start offset Y

	if (x<0) {
		outp(0x3d4,0x47); outp(0x3d5,0x00);
		outp(0x3d4,0x46); outp(0x3d5,0x00);
	} else {
		outp(0x3d4,0x47); outp(0x3d5,(uchar)x);
		outp(0x3d4,0x46); outp(0x3d5,((ushort)x)>>8);
	}
	if (y<0) {
		outp(0x3d4,0x49); outp(0x3d5,0x00);
		outp(0x3d4,0x48); outp(0x3d5,0x00);
	} else {
		outp(0x3d4,0x49); outp(0x3d5,(uchar)y);
		outp(0x3d4,0x48); outp(0x3d5,((ushort)y)>>8);
	}
}

void	ovid_eraseptr(struct MousePointerInfo *mpi) {
}

void	ovid_hideptr(struct MousePointerInfo *mpi,boolean new_state) {
	outp(0x3d4,0x45); outp(0x3d5,(inp(0x3d5) & 0xfe) | !!new_state);
}

ulong	revorder(ulong);
#pragma aux revorder="xchg al,ah","rol eax,16","xchg al,ah" value [eax] parm [eax] modify exact nomemory [eax];

void	ovid_changeptr(struct MousePointerInfo *mpi) {
	ulong nc1;
	ulong *pptr = pointer_memory;
	ulong *pptr2;
	uchar *ptr = mpi->image;
	int x,y,xs;

	// clear pointer memory

	for(y=256;y;y--) {
		*pptr++ = 0x0000FFFF;
	}

	pptr = pointer_memory;

	for(y=min(64,mpi->s_height);y;y--) {
		pptr2 = pptr;	pptr += 4;

		xs = mpi->s_width;

		while(xs>0) {
			for(x=min(16,xs);x;x--) {
				nc1<<=1;
				switch(*ptr++) {
				case 0: nc1|=0x00010000; break;
				case 1: nc1|=0x00000000; break;
				case 2: nc1|=0x00000001; break;
				};
			}
			if (xs<16) nc1 <<= (16-xs);
			*pptr2++ = revorder(nc1);
			xs -= 16;
		}
	}

	outp(0x3d4,0x45); inp(0x3d5);			// reset color stacks
	outp(0x3d4,0x4b); outp(0x3d5,mpi->low);		// background
	outp(0x3d4,0x45); inp(0x3d5);			// reset color stacks
	outp(0x3d4,0x4a); outp(0x3d5,mpi->high);	// foreground (this advances back stack, too -- #!&@$^*#&@ stupid!)
}


